function Create(self)
    --The Y coordinate at which to hover.
    self.hoverY = self.Pos.Y - 12;

    --The maximum speed of the train.
    self.maxspeed = 25;

    --The current speed of the train.
    self.curspeed = self.maxspeed;

    --If the train has crashed or not.
    self.crashed = false;

    --The time since the train has crashed.
    self.crashtimer = Timer();

    --This detects when to add some swaying motion to make movement seem more natural.
    self.swaytimer = Timer();

    --How much to sway (radians).
    self.sway = 0.25;

    --How far the train can rotate before crashing (radians)
    self.maxrot = 0.8;
	
	-- Add Turret
	local turrets = {"Sentry Gun Mini-G", "Sentry Gun A13-G", "Sentry Gun LAS-R-G"}
	
	-- self.turret = CreateACrab("Gatling Turret","Coalition.rte");
	self.turret = CreateACrab(turrets[math.random(#turrets)],"UniTec.rte");
	self.turret.Pos = Vector(self.Pos.X + 50,self.Pos.Y - 42);
	self.turret.Vel = self.Vel;
	self.turret.Team = self.Team;
	MovableMan:AddActor(self.turret);	
end

function Update(self)
    --If the train hasn't crashed...
    if self.crashed == false then
	--The following lines level out the train (until it has crashed).
	--This makes it hover.
	self.Vel.Y = self.Vel.Y - ((self.Pos.Y - self.hoverY)) / 35;

	--This makes sure it's hovering around the right spot.
	self.Pos.Y = ((self.Pos.Y * 9) + self.hoverY) / 10;

	--This keeps the train at a constant speed.
	--if self.Vel.X ~= 50 then
	--    self.Vel.X = (self.Vel.X * 9 + self.curspeed) / 10;
	--end

	--This keeps the train rotated in the right direction.
	if self.RotAngle ~= 0 then
	    self.AngularVel = (self.AngularVel * 74 - math.deg(self.RotAngle)) / 75;
	end

	--Crash the train if it's rotated too far.
	if self.RotAngle <= -self.maxrot or self.RotAngle >= self.maxrot then
	    self.crashed = true;
	    self.crashtimer:Reset();
	end

	if MovableMan:IsActor(self.turret) and MovableMan:IsActor(self) then
		local x = math.sin(self.RotAngle + 1.57 * 1.53) * 60;
		local y = math.cos(self.RotAngle + 1.57 * 1.53) * 60;
		
		self.turret.Pos = Vector(self.Pos.X + x, self.Pos.Y + y);
		self.turret.Vel = self.Vel;
		self.turret.RotAngle = self.RotAngle;
	end
	
	--If the train is dead, crash it.
	if self.Health <= 100 then
	    self.crashed = true;
	    self.crashtimer:Reset();
	end

	--Every 5 seconds, check if the train has any sway.  If not, apply some.
	if self.swaytimer:IsPastSimMS(5000) then
	    self.swaytimer:Reset();
	    self.AngularVel = self.sway;
	end
    elseif self.crashtimer:IsPastSimMS(5000) == true then
	--Explode five seconds after crashing.
	self:GibThis();
    end
end


function Destroy(self)
	if MovableMan:IsActor(self.turret) then
		self.turret.Health = 0
	end
end