-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function DryFlats:StartActivity()
	print("START! -- DryFlats:StartActivity()!");

	-- Music related variables
	self.MusicTimer = Timer()
	self.AgressiveLength = 10000
	self.IsAgressive = false
	self.IsStarted = false
	self.MusicCalm = "Winter (calm).ogg"
	self.MusicAgressive = "Ikevan (agressive).ogg"
	self.MusicModule = "Missions - Earth Music.rte"
	self.Health = {}
	
	for i = 1, 5 do
		self.Health[i] = 0;
	end

	self:StartMusic(self.MusicModule, self.MusicCalm)
	-- End of music related variables
	
	
	self.braindead = {};
	self.AssignedBrains = {};

	self.MOIDLimit = 200;

	self.PlayerGold = 0;

   	self.CPUTeam = Activity.TEAM_2;
   	self.CPU2Team = Activity.TEAM_3;
	self.PlayerTeam = Activity.TEAM_1;
	self.RogueTeam = -1;

	self.FightPhase = {NOFIGHT  = 1, CLEAN = 2}
	self.CurrentFightPhase = self.FightPhase.NOFIGHT;

	self.ModuleList = {"Coalition.rte" , "Dummy.rte"}
	self.CrabList = {"Gatling Drone" , "Dreadnought"}
	
	self.LWepList = {}
	self.LWepList[1] = {"Shotgun", "Compact Assault Rifle" , "Sniper Rifle"};
	self.LWepList[2] = {"Rail Pistol", "Nailgun" , "Blaster" , "Scouting Rifle" , "Nailer Cannon"};

	self.HWepList = {}
	self.HWepList[1] = {"Auto Shotgun", "Assault Rifle" , "Heavy Sniper Rifle" , "Uber Cannon" , "Revolver Cannon" , "Auto Cannon"};
	self.HWepList[2] = {"Blaster" , "Scouting Rifle" , "Nailer Cannon" , "Repeater" , "Impulse Cannon" , "Destroyer Cannon" , "Annihiliator"};

	self.EnemyList = {}
	self.EnemyList[1] = {"Soldier Heavy"};	
	self.EnemyList[2] = {"Dummy"};	

	self.ArmorProbability = 0.35
	self.HeavyWeaponProbability = 0.3
	
	-- Difficulty related variables
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.LWepList[1] = {"Auto Pistol" , "Heavy Pistol" };
		self.HWepList[1] = {"Assault Rifle"}
		self.LWepList[2] = {"Rail Pistol", "Nailgun"};
		self.HWepList[2] = {"Blaster"};
		self.PositiveIndex = 1.5;
		self.NegativeIndex = 0.5;
		self.ArmorProbability = 0
		self.HeavyWeaponProbability = 0.1
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.LWepList[1] = {"Shotgun", "Auto Pistol" , "Heavy Pistol" };
		self.HWepList[1] = {"Auto Shotgun", "Assault Rifle"}
		self.LWepList[2] = {"Rail Pistol", "Nailgun" , "Blaster" , "Scouting Rifle"};
		self.HWepList[2] = {"Blaster" , "Scouting Rifle"};
		self.PositiveIndex = 1.25;
		self.NegativeIndex = 0.75;
		self.ArmorProbability = 0.20
		self.HeavyWeaponProbability = 0.2
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.LWepList[1] = {"Shotgun", "Compact Assault Rifle" , "Sniper Rifle" , "Auto Pistol" , "Heavy Pistol" };
		self.HWepList[1] = {"Auto Shotgun", "Assault Rifle" , "Heavy Sniper Rifle"}
		self.LWepList[2] = {"Rail Pistol", "Nailgun" , "Blaster" , "Scouting Rifle"};
		self.HWepList[2] = {"Blaster" , "Scouting Rifle" , "Nailer Cannon" , "Impulse Cannon" , "Destroyer Cannon" , "Annihiliator"};
		self.PositiveIndex = 1.0;
		self.NegativeIndex = 1.0;
		self.ArmorProbability = 0.35
		self.HeavyWeaponProbability = 0.3
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.LWepList[1] = {"Shotgun", "Compact Assault Rifle" , "Sniper Rifle" , "Heavy Pistol" };
		self.HWepList[1] = {"Auto Shotgun", "Assault Rifle" , "Heavy Sniper Rifle" , "Revolver Cannon"}
		self.LWepList[2] = {"Rail Pistol" , "Blaster" , "Scouting Rifle" , "Nailer Cannon"};
		self.HWepList[2] = {"Blaster" , "Scouting Rifle" , "Nailer Cannon" , "Repeater" , "Impulse Cannon" , "Destroyer Cannon" , "Annihiliator"};
		self.PositiveIndex = 0.85;
		self.NegativeIndex = 1.15;
		self.ArmorProbability = 0.45
		self.HeavyWeaponProbability = 0.4
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.LWepList[1] = {"Shotgun", "Compact Assault Rifle" , "Sniper Rifle"};
		self.HWepList[1] = {"Auto Shotgun", "Assault Rifle" , "Heavy Sniper Rifle" , "Revolver Cannon" , "Auto Cannon"}
		self.LWepList[2] = {"Blaster" , "Scouting Rifle" , "Nailer Cannon"};
		self.HWepList[2] = {"Nailer Cannon" , "Repeater" , "Impulse Cannon" , "Destroyer Cannon" , "Annihiliator"};
		self.PositiveIndex = 0.70;
		self.NegativeIndex = 1.3;
		self.ArmorProbability = 0.55
		self.HeavyWeaponProbability = 0.5
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self.LWepList[1] = {"Compact Assault Rifle" , "Sniper Rifle"};
		self.HWepList[1] = {"Auto Shotgun", "Assault Rifle" , "Heavy Sniper Rifle" , "Revolver Cannon" , "Auto Cannon"}
		self.LWepList[2] = {"Repeater", "Nailer Cannon"};
		self.HWepList[2] = {"Repeater" , "Impulse Cannon" , "Destroyer Cannon" , "Annihiliator"};
		self.PositiveIndex = 0.55;
		self.NegativeIndex = 1.45;
		self.ArmorProbability = 0.65
		self.HeavyWeaponProbability = 0.6
	end			
	
	self.AlertTriggered = false;

	self.BehemothInstalled = false
	if PresetMan:GetModuleID("DummyBehemoth.rte") ~= -1 then
		print ("Behemoth installed!!!")
		self.BehemothInstalled = true;
	end
	self.BehemothSpawned = false
	self.Behemoth = nil
	
	-- We cant't add areas in the loop because CC will never find a suitable location 
	-- for our activity
	self.Enemy = {}

	self.Enemy[1] = {}
	self.Enemy[1][1] = SceneMan.Scene:GetArea("Enemy1-1");
	self.Enemy[1][2] = SceneMan.Scene:GetArea("Enemy1-2");
	self.Enemy[1][3] = SceneMan.Scene:GetArea("Enemy1-3");
	self.Enemy[1][4] = SceneMan.Scene:GetArea("Enemy1-4");
	self.Enemy[1][5] = SceneMan.Scene:GetArea("Enemy1-5");
	self.Enemy[1][6] = SceneMan.Scene:GetArea("Enemy1-6");
	self.Enemy[1][7] = SceneMan.Scene:GetArea("Enemy1-7");
	self.Enemy[1][8] = SceneMan.Scene:GetArea("Enemy1-8");
	self.Enemy[1][9] = SceneMan.Scene:GetArea("Enemy1-9");
	self.Enemy[1][10] = SceneMan.Scene:GetArea("Enemy1-10");

	self.Enemy[2] = {}
	self.Enemy[2][1] = SceneMan.Scene:GetArea("Enemy2-1");
	self.Enemy[2][2] = SceneMan.Scene:GetArea("Enemy2-2");
	self.Enemy[2][3] = SceneMan.Scene:GetArea("Enemy2-3");
	self.Enemy[2][4] = SceneMan.Scene:GetArea("Enemy2-4");
	self.Enemy[2][5] = SceneMan.Scene:GetArea("Enemy2-5");
	self.Enemy[2][6] = SceneMan.Scene:GetArea("Enemy2-6");
	self.Enemy[2][7] = SceneMan.Scene:GetArea("Enemy2-7");
	self.Enemy[2][8] = SceneMan.Scene:GetArea("Enemy2-8");
	self.Enemy[2][9] = SceneMan.Scene:GetArea("Enemy2-9");
	self.Enemy[2][10] = SceneMan.Scene:GetArea("Enemy2-10");

	self.ShipReturned = false;

	self.Patrol = {}

	self.Patrol[1] = {}
	self.Patrol[1][1] = SceneMan.Scene:GetArea("Patrol1-1");
	self.Patrol[1][2] = SceneMan.Scene:GetArea("Patrol1-2");
	self.Patrol[1][3] = SceneMan.Scene:GetArea("Patrol1-3");
	self.Patrol[1][4] = SceneMan.Scene:GetArea("Patrol1-4");

	self.Patrol[2] = {}
	self.Patrol[2][1] = SceneMan.Scene:GetArea("Patrol2-1");
	self.Patrol[2][2] = SceneMan.Scene:GetArea("Patrol2-2");
	self.Patrol[2][3] = SceneMan.Scene:GetArea("Patrol2-3");
	self.Patrol[2][4] = SceneMan.Scene:GetArea("Patrol2-4");
	
	self.GenericTimer = Timer();
	self.GenericTimer:Reset();

	self.SpawnTimer = Timer();
	self.SpawnTimer:Reset();
	
	self.EnumEven = true;
	
	-- Spawn enemy brains
	self.EnemyBrains = {}
	
	self.EnemyBrains[1] = CreateActor("Brain Case" , "Base.rte");
	self.EnemyBrains[1].Team = self.CPUTeam;
	self.EnemyBrains[1].AIMode = Actor.AIMODE_SENTRY;
	self.EnemyBrains[1].Pos = Vector(335, 1378);
	MovableMan:AddActor(self.EnemyBrains[1]);

	self.EnemyBrains[2] = CreateActor("Brain Case" , "Base.rte");
	self.EnemyBrains[2].Team = self.CPU2Team;
	self.EnemyBrains[2].AIMode = Actor.AIMODE_SENTRY;
	self.EnemyBrains[2].Pos = Vector(3505, 1378);
	MovableMan:AddActor(self.EnemyBrains[2]);
	
	-- Spawn Our Heroes
	self.Xiin = CreateAHuman("Xiin" , "UniTec.rte");
	self.Xiin.Team = self.PlayerTeam;
	self.Xiin:AddInventoryItem(CreateHDFirearm("Zealot Small Gun" , "UniTec.rte"));
	self.Xiin:AddInventoryItem(CreateHDFirearm("Zealot Long Gun" , "UniTec.rte"));
	self.Xiin.AIMode = Actor.AIMODE_SENTRY;
	for player = 0, self.PlayerCount - 1 do
		self:SetPlayerBrain(self.Xiin, player);
	end

	self.Plox = CreateAHuman("Plox" , "UniTec.rte");
	self.Plox.Team = self.PlayerTeam;
	self.Plox:AddInventoryItem(CreateHDFirearm("Zealot Medium Gun" , "UniTec.rte"));
	self.Plox:AddInventoryItem(CreateHDFirearm("Zealot Heavy Gun" , "UniTec.rte"));
	self.Plox.AIMode = Actor.AIMODE_SENTRY;

	--[[self.HeroShip2 = CreateACDropShip("Zealot Saucer" , "Unitec.rte");
	self.HeroShip2.Team = self.PlayerTeam;
	self.HeroShip2.Pos = Vector(SceneMan.Scene:GetArea("DropZone"):GetCenterPoint().X - 250 , 600);
	self.HeroShip2:SetControllerMode(Controller.CIM_AI, -1);
	MovableMan:AddActor(self.HeroShip2);]]--
	
	self.HeroShip = CreateACDropShip("Zealot Saucer" , "Unitec.rte");
	self.HeroShip.Team = self.PlayerTeam;
	self.HeroShip:AddInventoryItem(self.Xiin);
	self.HeroShip:AddInventoryItem(self.Plox);
	--self.HeroShip.Pos = Vector(SceneMan.Scene:GetArea("DropZone"):GetCenterPoint().X + 50 , 0);
	self.HeroShip.Pos = Vector(SceneMan.Scene:GetArea("DropZone"):GetCenterPoint().X , 400);
	self.HeroShip:SetControllerMode(Controller.CIM_AI, -1);
	MovableMan:AddActor(self.HeroShip);

	
	self:SpawnEnemies();
	self:SetTeamFunds(0 , self.PlayerTeam);
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
-- This function is called when mission is paused
function DryFlats:PauseActivity(pause)
    print("PAUSE! -- DryFlats:PauseActivity()!");
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
-- This function is called after mission has ended
function DryFlats:EndActivity()
    print("END! -- DryFlats:EndActivity()!");
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function DryFlats:SpawnEnemies()
	print ("SpawnEnemies")
	local ship;
	local actor;
	
	-- Spawn ordinary enemy
	for i = 1, 10 do
		for j = 1, 2 do
			if math.random() < 0.80 then
				if math.random() < 0.90 then
					if MovableMan:GetMOIDCount() <= self.MOIDLimit then
						if math.random() < self.ArmorProbability then
							actor = CreateACrab(self.CrabList[j] , self.ModuleList[j]);
							if j == 2 then
								actor.Pos = self.Enemy[j][i]:GetCenterPoint() + Vector(0,20);
							else
								actor.Pos = self.Enemy[j][i]:GetCenterPoint();
							end
							actor.Team = j;
							actor.AIMode = Actor.AIMODE_SENTRY;
							MovableMan:AddActor(actor);					
							if j == 2 then
								actor.HFlipped = true
							end
						else
							actor = CreateAHuman(self.EnemyList[j][math.random(#self.EnemyList[j])] , self.ModuleList[j]);
							if math.random() < self.HeavyWeaponProbability then
								actor:AddInventoryItem(CreateHDFirearm(self.HWepList[j][math.random(#self.HWepList[j])] , self.ModuleList[j]))
							else
								actor:AddInventoryItem(CreateHDFirearm(self.LWepList[j][math.random(#self.LWepList[j])] , self.ModuleList[j]))
							end
							actor.Pos = self.Enemy[j][i]:GetCenterPoint();
							actor.Team = j; -- Gameplay
							actor.AIMode = Actor.AIMODE_SENTRY;
							if j == 2 then
								actor.HFlipped = true
							end
							
							if i == 7 then
								if j == 1 then
									actor.HFlipped = true
								else
									actor.HFlipped = false
								end
							end
							
							MovableMan:AddActor(actor);
						end
					end
				end
			end
		end
	end
	
	--Spawn patrol
	for i = 1, 4 do
		for j = 1, 2 do
			if MovableMan:GetMOIDCount() <= self.MOIDLimit then
				actor = CreateAHuman(self.EnemyList[j][math.random(#self.EnemyList[j])] , self.ModuleList[j]);
				--if math.random() < 0.15 then
				--	actor:AddInventoryItem(CreateHDFirearm(self.HWepList[j][math.random(#self.HWepList[j])] , self.ModuleList[j]))
				--else
					actor:AddInventoryItem(CreateHDFirearm(self.LWepList[j][math.random(#self.LWepList[j])] , self.ModuleList[j]))
				--end
				actor.Pos = self.Patrol[j][i]:GetCenterPoint();
				actor.Team = j; -- Gameplay
				actor.AIMode = Actor.AIMODE_GOTO;
				actor:ClearAIWaypoints()
				actor:AddAISceneWaypoint(SceneMan.Scene:GetArea("DropZone"):GetCenterPoint())
				
				MovableMan:AddActor(actor);
			end
		end
	end
	
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function DryFlats:UpdateActivity()
   	self:ClearObjectivePoints();

	self:ProcessMusic(self.Xiin, self.Plox, nil, nil, nil)
	
	if self.CurrentFightPhase == self.FightPhase.NOFIGHT then
		self:PhaseNoFight();
	elseif self.CurrentFightPhase == self.FightPhase.CLEAN then
		self:PhaseClean();
	end
	
	self:DoBrainSelection()
	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function DryFlats:PhaseNoFight()
	-- Control ship
	if MovableMan:IsActor(self.HeroShip2) then
		for player = 0, self.PlayerCount - 1 do
			self:SetObservationTarget(self.HeroShip2.Pos, player);
		end
		self.HeroShip2:SetControllerMode(Controller.CIM_AI, -1);
	end	
	
	if MovableMan:IsActor(self.HeroShip) then
		for player = 0, self.PlayerCount - 1 do
			if not MovableMan:IsActor(self.HeroShip2) then
				self:SetObservationTarget(self.HeroShip.Pos, player);
			end
		end
		self.HeroShip:SetControllerMode(Controller.CIM_AI, -1);
	end	
	
	-- Show heroes marks
	if not self.GenericTimer:IsPastSimMS(8000) then
		if MovableMan:IsActor(self.Xiin) then
			self:AddObjectivePoint("Xiin", self.Xiin.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
		
		if MovableMan:IsActor(self.Plox) then
			self:AddObjectivePoint("Plox", self.Plox.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	else
		self:AdvanceToClean();
	end

	for player = 0, self.PlayerCount - 1 do
		FrameMan:ClearScreenText(player);
		FrameMan:SetScreenText("Annihilate enemy leaders\nXiin and Plox must survive", player, -1, 1000, true);
	end
	
	-- Kill all targets
	--for actor in MovableMan.Actors do
	--	if actor.Team ~= self.PlayerTeam and actor.ClassName == "AHuman" then
	-- 		actor.Health = actor.Health - math.random();
	--	end
	--end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function DryFlats:AdvanceToClean()
	print ("AdvanceToClean")
	self:SetTeamFunds(self.PlayerGold , self.PlayerTeam);
	
	self.CurrentFightPhase = self.FightPhase.CLEAN;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function DryFlats:PhaseClean()
	-- Control ship
	if MovableMan:IsActor(self.HeroShip2) then
		self.HeroShip2.Vel = Vector(0,-15)
		self.HeroShip2:SetControllerMode(Controller.CIM_AI, -1);
	end	
	
	if MovableMan:IsActor(self.HeroShip) then
		self.HeroShip.Vel = Vector(0,-15)
		self.HeroShip:SetControllerMode(Controller.CIM_AI, -1);
	else
		self:CheckLooser();
	end	
	
	local brainsactive = 0

	-- Mark closest actors
	for i = 1, 2 do
		if not MovableMan:IsActor(self.EnemyBrains[i]) then
			self.EnemyBrains[i] = nil;
			
			-- Spawn behemoth
			if self.BehemothInstalled then
				if i == 2 and not self.BehemothSpawned then
					self.Behemoth = CreateAHuman("Behemoth" , "DummyBehemoth.rte")
					self.Behemoth.Pos = SceneMan.Scene:GetArea("DropZone"):GetCenterPoint()
					self.Behemoth.Team = self.CPU2Team;
					self.Behemoth.AIMode = Actor.AIMODE_GOTO;
					self.Behemoth:ClearAIWaypoints()
					
					local pos = SceneMan.Scene:GetArea("DropZone"):GetCenterPoint()
					
					if self.EnemyBrains[1] ~= nil then
						self.Behemoth:AddAISceneWaypoint(Vector(pos.X - 1400, pos.Y))
					else
						self.Behemoth:AddAISceneWaypoint(Vector(pos.X + 1400, pos.Y))
					end
					
					MovableMan:AddActor(self.Behemoth)
					self.BehemothSpawned = true;
					
					local actor = self:GetControlledActor(self.PlayerTeam);
					local pos = SceneMan.Scene:GetArea("DropZone"):GetCenterPoint()
					if actor ~= nil then
						pos = actor.Pos;
					end
					
					local fx = CreateAEmitter("Godzilla Roar");
					fx.Pos = pos;
					MovableMan:AddParticle(fx);	
				end
			end
		else
			brainsactive = brainsactive + 1
		end
	
		if self.EnemyBrains[i] ~= nil then
			self:AddObjectivePoint("Kill", self.EnemyBrains[i].AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	end
	
	if self.BehemothSpawned then
		if not MovableMan:IsActor(self.Behemoth) then
			self.Behemoth = nil;
		else
			brainsactive = brainsactive + 1
		end

		if self.Behemoth ~= nil then
			self:AddObjectivePoint("Kill", self.Behemoth.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	end
	
	if brainsactive == 0 then
		if self.ActivityState ~= Activity.OVER then
			self.WinnerTeam = self.PlayerTeam;
			ActivityMan:EndActivity();
			for player = 0, self.PlayerCount - 1 do
				self.braindead[player] = true;
				FrameMan:ClearScreenText(player);
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function DryFlats:DoBrainSelection()
	if self.ActivityState ~= Activity.OVER then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);

			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) then
				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self.AssignedBrains[player] = newBrain;
					self:SwitchToActor(newBrain, player, team);
				end
			else
				self:SetObservationTarget(brain.Pos, player)
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Check winning conditions
-----------------------------------------------------------------------------------------
function DryFlats:CheckLooser()
	if self.ActivityState ~= Activity.OVER then
		if MovableMan:IsActor(self.Xiin) then
			if self.Xiin.Health <= 0 then
				self.Xiin = nil
			end
		else
			self.Xiin = nil
		end

		if MovableMan:IsActor(self.Plox) then
			if self.Plox.Health <= 0 then
				self.Plox = nil
			end
		else
			self.Plox = nil
		end
	
		if self.Xiin == nil or self.Plox == nil then
			for player = 0, self.PlayerCount - 1 do
				if MovableMan:IsActor(self.Xiin) then
					self:SetPlayerBrain(self.Xiin , player);
					self:SwitchToActor(self.Xiin, player, self.PlayerTeam);
				elseif MovableMan:IsActor(self.Plox) then
					self:SetPlayerBrain(self.Plox , player);
					self:SwitchToActor(self.Plox, player, self.PlayerTeam);
				end
			end
		
			self.WinnerTeam = self.CPUTeam;
			ActivityMan:EndActivity();
			for player = 0, self.PlayerCount - 1 do
				self.braindead[player] = true;
				FrameMan:ClearScreenText(player);
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Enter orbit, clear money
-----------------------------------------------------------------------------------------
function DryFlats:CraftEnteredOrbit()
	self:SetTeamFunds(0 , self.PlayerTeam);
end
-----------------------------------------------------------------------------------------
-- Triggers agressive music if some of critical actors was wounded
-----------------------------------------------------------------------------------------
function DryFlats:ProcessMusic(a1,a2,a3,a4,a5)
	local actors = {}
	
	actors[1] = a1;
	actors[2] = a2;
	actors[3] = a3;
	actors[4] = a4;
	actors[5] = a5;
	
	for i = 1, 5 do
		if MovableMan:IsActor(actors[i]) then
			if actors[i].Health < self.Health[i] then
				if not self.IsAgressive then
					self.IsAgressive = true;
					self:StartMusic(self.MusicModule, self.MusicAgressive)
				end
				self.MusicTimer:Reset();
				self.Health[i] = actors[i].Health
				break;
			end
			self.Health[i] = actors[i].Health
		end
	end

	if self.IsAgressive then
		if self.MusicTimer:IsPastSimMS(self.AgressiveLength) then
			self.IsAgressive = false;
			self:StartMusic(self.MusicModule, self.MusicCalm)
		end
	end
end
-----------------------------------------------------------------------------------------
-- Starts music from file if it's installed
-----------------------------------------------------------------------------------------
function DryFlats:StartMusic(modulename , musicfile)
	local path = "./"..modulename.."/"..musicfile

	if self:IsFilePathExists(path) then
		AudioMan:ClearMusicQueue();
		AudioMan:PlayMusic(path, -1, -1);
	else
		print ("Can't find music: "..path);
	end	
end
-----------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------
function DryFlats:IsFilePathExists(path)
	io = require("io");
	
	local file = io.open(path , "r");
	
	if file == nil then
		return false;
	end
	
	file:close();
	return true;
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------



































