-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function Excavation:StartActivity()
	print("START! -- Excavation:StartActivity()!");
	
	-- Music related variables
	self.MusicTimer = Timer()
	self.AgressiveLength = 10000
	self.IsAgressive = false
	self.IsStarted = false
	self.MusicCalm = "Ambientodelica (calm).ogg"
	self.MusicAgressive = "Ambientodelica (agressive).ogg"
	self.MusicModule = "Missions - Earth Music.rte"
	self.Health = {}
	
	for i = 1, 5 do
		self.Health[i] = 0;
	end

	self:StartMusic(self.MusicModule, self.MusicCalm)
	-- End of music related variables
	
	self.braindead = {};
	self.AssignedBrains = {};

	self.MOIDLimit = 200;

	self.PlayerGold = 500;

   	self.CPUTeam = Activity.TEAM_2;
	self.PlayerTeam = Activity.TEAM_1;
	self.RogueTeam = -1;

	self.FightPhase = {NOFIGHT  = 1, CLEAN = 2, CAPTURE = 3}
	self.CurrentFightPhase = self.FightPhase.NOFIGHT;
	
	self.LWepList = {"Peacemaker" , "Glock" , "Desert Eagle" , "Uzi" , "Shortgun"};
	self.WepList = {"M16" , "AK-47" , "M1 Garand" , "Pumpgun"};
	self.HWepList = {"Spas 12" , "Kar98" , "M60"};
	self.EnemyList = {"Mia" , "Dimitri" , "Sandra" , "Gordon"};	
	self.RobotList = {"Robot 1" , "Robot 2"};	
	self.LastPos = nil;

	self.HeavyWeaponProbability = 0.3
	
	-- Difficulty related variables
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.LWepList = {"Peacemaker" , "Glock" , "Desert Eagle" };
		self.WepList = {"Pumpgun"};
		self.HWepList = {"Spas 12"};
		self.HeavyWeaponProbability = 0.1
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.LWepList = {"Peacemaker" , "Glock" , "Desert Eagle" , "Shortgun"};
		self.WepList = {"AK-47" , "Pumpgun"};
		self.HWepList = {"Spas 12"};
		self.HeavyWeaponProbability = 0.2
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.LWepList = {"Peacemaker", "Desert Eagle" , "Uzi" , "Shortgun"};
		self.WepList = {"AK-47" , "M1 Garand" , "Pumpgun"};
		self.HWepList = {"Spas 12" , "Kar98"};
		self.HeavyWeaponProbability = 0.3
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.LWepList = {"Peacemaker" , "Uzi" };
		self.WepList = {"M16" , "AK-47" , "M1 Garand"};
		self.HWepList = {"Spas 12" , "Kar98" , "M60"};
		self.HeavyWeaponProbability = 0.4
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.LWepList = {"Uzi"};
		self.WepList = {"M16" , "M1 Garand"};
		self.HWepList = {"Kar98" , "M60"};
		self.HeavyWeaponProbability = 0.5
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self.LWepList = {"Uzi"};
		self.WepList = {"M16"};
		self.HWepList = {"Kar98" , "M60", "RPG-7"};
		self.HeavyWeaponProbability = 0.6
	end
	
	self.AlertTriggered = false;
	
	self.MinerSpawn = SceneMan.Scene:GetArea("MinerSpawn");
	self.RoninLeaderBunker = SceneMan.Scene:GetArea("RoninLeaderBunker");
	
	-- We cant't add areas in the loop because CC will never find a suitable location 
	-- for our activity
	self.Ronin = {}
	self.Ronin[1] = SceneMan.Scene:GetArea("Ronin1");
	self.Ronin[2] = SceneMan.Scene:GetArea("Ronin2");
	self.Ronin[3] = SceneMan.Scene:GetArea("Ronin3");
	self.Ronin[4] = SceneMan.Scene:GetArea("Ronin4");
	self.Ronin[5] = SceneMan.Scene:GetArea("Ronin5");
	self.Ronin[6] = SceneMan.Scene:GetArea("Ronin6");
	self.Ronin[7] = SceneMan.Scene:GetArea("Ronin7");
	self.Ronin[8] = SceneMan.Scene:GetArea("Ronin8");
	self.Ronin[9] = SceneMan.Scene:GetArea("Ronin9");
	self.Ronin[10] = SceneMan.Scene:GetArea("Ronin10");
	self.Ronin[11] = SceneMan.Scene:GetArea("Ronin11");
	self.Ronin[12] = SceneMan.Scene:GetArea("Ronin12");
	self.Ronin[13] = SceneMan.Scene:GetArea("Ronin13");
	self.Ronin[14] = SceneMan.Scene:GetArea("Ronin14");
	self.Ronin[15] = SceneMan.Scene:GetArea("Ronin15");
	self.Ronin[16] = SceneMan.Scene:GetArea("Ronin16");
	self.Ronin[17] = SceneMan.Scene:GetArea("Ronin17");
	self.Ronin[18] = SceneMan.Scene:GetArea("Ronin18");
	self.Ronin[19] = SceneMan.Scene:GetArea("Ronin19");
	self.Ronin[20] = SceneMan.Scene:GetArea("Ronin20");
	
	self.RoninGuard = {}
	self.RoninGuard[1] = SceneMan.Scene:GetArea("Guard1");
	self.RoninGuard[2] = SceneMan.Scene:GetArea("Guard2");
	self.RoninGuard[3] = SceneMan.Scene:GetArea("Guard3");

	self.PatrolZones = {}; 
	self.PatrolWaypoints = {};

	self.PatrolZones[1] = SceneMan.Scene:GetArea("PatrolZone1");
	self.PatrolZones[2] = SceneMan.Scene:GetArea("PatrolZone2");
	self.PatrolZones[3] = SceneMan.Scene:GetArea("PatrolZone3");
	self.PatrolZones[4] = SceneMan.Scene:GetArea("PatrolZone4");
	self.PatrolZones[5] = SceneMan.Scene:GetArea("PatrolZone5");
	
	self.PatrolWaypoints[1] = {SceneMan.Scene:GetArea("PatrolPoint1L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint1R"):GetCenterPoint()};
	self.PatrolWaypoints[2] = {SceneMan.Scene:GetArea("PatrolPoint2L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint2R"):GetCenterPoint()};
	self.PatrolWaypoints[3] = {SceneMan.Scene:GetArea("PatrolPoint3L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint3R"):GetCenterPoint()};
	self.PatrolWaypoints[4] = {SceneMan.Scene:GetArea("PatrolPoint4L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint4R"):GetCenterPoint()};
	self.PatrolWaypoints[5] = {SceneMan.Scene:GetArea("PatrolPoint5L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint5R"):GetCenterPoint()};
	
	self.GenericTimer = Timer();
	self.GenericTimer:Reset();

	self.SpawnTimer = Timer();
	self.SpawnTimer:Reset();
	
	self.EnumEven = true;
	
	--Spawn Our Heroes
	self.Jack = CreateAHuman("Jack" , "UniTec.rte");
	self.Jack.Team = self.PlayerTeam;
	self.Jack:AddInventoryItem(CreateHDFirearm("Franchi SPAS-15" , "UniTec.rte"));
	self.Jack.AIMode = Actor.AIMODE_SENTRY;
	for player = 0, self.PlayerCount - 1 do
		self:SetPlayerBrain(self.Jack, player);
	end

	self.Lynx = CreateAHuman("Brain Lynx" , "UniTec.rte");
	self.Lynx.Team = self.PlayerTeam;
	self.Lynx:AddInventoryItem(CreateHDFirearm("SV Dragunov" , "UniTec.rte"));
	self.Lynx.AIMode = Actor.AIMODE_SENTRY;

	self.Jess = CreateAHuman("Brain Jess" , "UniTec.rte");
	self.Jess.Team = self.PlayerTeam;
	self.Jess:AddInventoryItem(CreateHDFirearm("HK MP5K" , "UniTec.rte"));
	self.Jess.AIMode = Actor.AIMODE_SENTRY;
	
	self.HeroShip = CreateACDropShip("UniTec Drop Ship" , "Unitec.rte");
	self.HeroShip.Team = self.PlayerTeam;
	self.HeroShip:AddInventoryItem(self.Jack);
	self.HeroShip:AddInventoryItem(self.Lynx);
	self.HeroShip:AddInventoryItem(self.Jess);
	self.HeroShip.Pos = Vector(SceneMan.Scene:GetArea("DropZone"):GetCenterPoint().X , 20);
	self.HeroShip:SetControllerMode(Controller.CIM_AI, -1);
	MovableMan:AddActor(self.HeroShip);
	
	self:SpawnRonins();
	self:SetTeamFunds(0 , self.PlayerTeam);
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
-- This function is called when mission is paused
function Excavation:PauseActivity(pause)
    print("PAUSE! -- Excavation:PauseActivity()!");
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
-- This function is called after mission has ended
function Excavation:EndActivity()
    print("END! -- Excavation:EndActivity()!");
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function Excavation:SpawnRonins()
	print ("SpawnRonin")
	local ship;
	local actor;

	-- Spawn Ronin commander
	self.RoninLeader = CreateAHuman("Dafred" , "Ronin.rte");
	self.RoninLeader:AddInventoryItem(CreateHDFirearm("Glock" , "Ronin.rte"))
	self.RoninLeader.Pos = SceneMan.Scene:GetArea("RoninLeader"):GetCenterPoint();
	self.RoninLeader.Team = self.CPUTeam; -- Gameplay
	self.RoninLeader.GetsHitByMOs = false;
	self.RoninLeader.HitsMOs = false;	
	self.RoninLeader.AIMode = Actor.AIMODE_SENTRY;
	MovableMan:AddActor(self.RoninLeader);
	
	-- Spawn leader guards
	for i = 1, 3 do
		if MovableMan:GetMOIDCount() <= self.MOIDLimit then
			actor = CreateAHuman("Brutus" , "Ronin.rte");
			actor:AddInventoryItem(CreateHDFirearm(self.HWepList[math.random(#self.HWepList)] , "Ronin.rte"))
			actor:AddInventoryItem(CreateHDFirearm(self.HWepList[math.random(#self.HWepList)] , "Ronin.rte"))
			actor:AddInventoryItem(CreateHDFirearm(self.LWepList[math.random(#self.LWepList)] , "Ronin.rte"))
			actor.Pos = self.RoninGuard[i]:GetCenterPoint();
			actor.Team = self.CPUTeam; -- Gameplay
			actor.AIMode = Actor.AIMODE_SENTRY;
			if i == 3 then
				actor.HFlipped = true
			end
			MovableMan:AddActor(actor);
		end
	end
	
	-- Spawn ordinary Ronin
	for i = 1, 20 do
		if math.random() < 0.6 then
			if MovableMan:GetMOIDCount() <= self.MOIDLimit then
				actor = CreateAHuman(self.EnemyList[math.random(#self.EnemyList)] , "Ronin.rte");
				if math.random() < self.HeavyWeaponProbability then
					actor:AddInventoryItem(CreateHDFirearm(self.HWepList[math.random(#self.HWepList)] , "Ronin.rte"))
				else
					actor:AddInventoryItem(CreateHDFirearm(self.WepList[math.random(#self.WepList)] , "Ronin.rte"))
				end
				if math.random() < 0.7 then
					actor:AddInventoryItem(CreateHDFirearm(self.LWepList[math.random(#self.LWepList)] , "Ronin.rte"))
				end
				actor.Pos = self.Ronin[i]:GetCenterPoint();
				actor.Team = self.CPUTeam; -- Gameplay
				--actor.Team = self.PlayerTeam; -- Debug
				actor.AIMode = Actor.AIMODE_SENTRY;
				
				if i == 1 or i == 5 or i == 8 or i == 9 or i == 14 or i == 17 or i == 18 then
					actor.HFlipped = true
				end
				
				MovableMan:AddActor(actor);
			end
		end
	end
	
	-- Spawn robot workers
	for i = 1, 5 do
		if MovableMan:GetMOIDCount() <= self.MOIDLimit then
			actor = CreateAHuman(self.RobotList[math.random(#self.RobotList)] , "Base.rte");
			actor:AddInventoryItem(CreateHDFirearm(self.LWepList[math.random(#self.LWepList)] , "Ronin.rte"))
			actor:AddInventoryItem(CreateHDFirearm("Heavy Digger" , "Base.rte"))
			actor.Pos = self.MinerSpawn:GetRandomPoint();
			actor.Team = self.CPUTeam; -- Gameplay
			actor.AIMode = Actor.AIMODE_GOLDDIG;
			MovableMan:AddActor(actor);
		end
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Excavation:IsEven(number)
	if number % 2 == 0 then
		return true;
	else
		return false;
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Excavation:PatrolControl()
	local unitcount = 0;

	-- Set flag to chech even or odd actors
	self.EnumEven = not self.EnumEven;
	
	-- Resend all enemy troops to closes patrol areas if alert is off
	-- Scan all patrol zones. If we have AIMODE_SENTRY troops there,
	-- GOTO them to the most far patrol point
	for actor in MovableMan.Actors do
		-- to reduce the lag at every cycle we control only odd or even actor. It would be more efficint to count actors every time, because more ID's can be odd or even but it was written some time ago when I was dumber )))
		if actor.Team == self.CPUTeam and actor.AIMode ~= Actor.AIMODE_GOTO and actor.ClassName == "AHuman" then
			unitcount = unitcount + 1;
			if self:IsEven(unitcount) == self.EnumEven then
				for i = 1 , #self.PatrolZones do
					if self.PatrolZones[i]:IsInside(actor.Pos) then
						-- Calc distances to available patrol waypoint and send actor to the most far
						local dist1 = math.sqrt((actor.Pos.X - self.PatrolWaypoints[i][1].X) ^ 2 + (actor.Pos.Y - self.PatrolWaypoints[i][1].Y) ^ 2);
						local dist2 = math.sqrt((actor.Pos.X - self.PatrolWaypoints[i][2].X) ^ 2 + (actor.Pos.Y - self.PatrolWaypoints[i][2].Y) ^ 2);

						-- Flash white for debugging purposes
						-- Also you can spawn actor of your own team change team in IF and enable DrawWaypoints to see where you troops were sent. VERY helpful!
						-- actor:FlashWhite(50);
						actor.AIMode = Actor.AIMODE_GOTO;
						actor:ClearAIWaypoints();
						actor:DrawWaypoints(true);
						if dist1 < dist2 then
							actor:AddAISceneWaypoint(self.PatrolWaypoints[i][2]);
						else
							actor:AddAISceneWaypoint(self.PatrolWaypoints[i][1]);
						end --if
						break;
					end -- if
				end -- for
			end -- if 
		end -- if
	end -- for		
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function Excavation:UpdateActivity()
   	self:ClearObjectivePoints();

	self:ProcessMusic(self.Jack, self.Jess, self.Lynx, nil, nil)
	
	if self.CurrentFightPhase == self.FightPhase.NOFIGHT then
		self:PhaseNoFight();
	elseif self.CurrentFightPhase == self.FightPhase.CLEAN then
		self:PhaseClean();
	elseif self.CurrentFightPhase == self.FightPhase.CAPTURE then
		self:PhaseCapture();
	end

	if MovableMan:IsActor(self.RoninLeader) then
		self:AddObjectivePoint("Capture!", self.RoninLeader.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
	end
	
	-- print (self.CurrentFightPhase)
	
	self:CheckLoser();
	self:PatrolControl();
	self:DoBrainSelection()
	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Excavation:PhaseNoFight()
	-- Control ship
	if MovableMan:IsActor(self.HeroShip) then
		for player = 0, self.PlayerCount - 1 do
			self:SetObservationTarget(self.HeroShip.Pos, player);
		end
		self.HeroShip:SetControllerMode(Controller.CIM_AI, -1);
	end	

	-- Show heroes marks
	if not self.GenericTimer:IsPastSimMS(12000) then
		if MovableMan:IsActor(self.Jack) then
			self:AddObjectivePoint("Jack", self.Jack.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
		
		if MovableMan:IsActor(self.Lynx) then
			self:AddObjectivePoint("Lynx", self.Lynx.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end

		if MovableMan:IsActor(self.Jess) then
			self:AddObjectivePoint("Jess", self.Jess.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	else
		self:AdvanceToClean();
	end

	for player = 0, self.PlayerCount - 1 do
		FrameMan:ClearScreenText(player);
		FrameMan:SetScreenText("Eliminate all ronin troops but keep their leader alive!!!\nDont waste any of your teammates", player, -1, 1000, true);
	end
	
	-- Kill all targets
	--for actor in MovableMan.Actors do
	--	if actor.Team == self.CPUTeam and actor.PresetName ~= "Dafred" and actor.ClassName == "AHuman" then
	-- 		actor.Health = actor.Health - math.random();
	--	end
	--end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Excavation:AdvanceToClean()
	print ("AdvanceToClean")
	self:SetTeamFunds(self.PlayerGold , self.PlayerTeam);
	
	self.CurrentFightPhase = self.FightPhase.CLEAN;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Excavation:PhaseClean()
	local enemiesleft = 0;
	local triggeralert = false;
	
	local curactor = ActivityMan:GetActivity():GetControlledActor(self.PlayerTeam);
	local maxactorstotrack = 5; -- Actors number to track
	local enemies = {}
	local dists = {}
	
	for i = 1, maxactorstotrack do
		enemies[i] = nil;
		dists[i] = 100000;
	end
	
	-- Count remaining enemy troops
	for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam and actor.PresetName ~= "Dafred" and actor.ClassName == "AHuman" then
			enemiesleft = enemiesleft + 1;
			
			if MovableMan:IsActor(curactor) then
				--local dist = math.sqrt((actor.Pos.X - curactor.Pos.X) ^ 2 + (actor.Pos.Y - curactor.Pos.Y) ^ 2);
				local dist = SceneMan:ShortestDistance(actor.Pos, curactor.Pos, true).Magnitude;
				
				local maxdist = 0;
				local maxindex = 0;
				
				-- Find most far actor
				for i = 1, maxactorstotrack do
					if dists[i] > maxdist then
						maxdist = dists[i];
						maxindex = i;
					end
				end
				
				-- If our actor closer to player-controlled actor than the most far, then replace it
				if dist < maxdist then
					dists[maxindex] = dist;
					enemies[maxindex] = actor;
				end
			end
		end
			
		-- If we're close to Dafred - trigger alert
		if actor.Team == self.PlayerTeam then
			if not self.AlertTriggered then
				if self.RoninLeaderBunker:IsInside(actor.Pos) then
					triggeralert = true;
				end
			end
		end
	end

	for player = 0, self.PlayerCount - 1 do
		FrameMan:ClearScreenText(player);
		FrameMan:SetScreenText("Remaining targets: "..tostring(enemiesleft), player, 0, 1, false);
	end

	-- Mark closest actors
	for i = 1, maxactorstotrack do
		if enemies[i] ~= nil then
			self:AddObjectivePoint("Terminate", enemies[i].AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	end

	if enemiesleft == 0 then
		self:AdvanceToCapture();
	end
	
	-- Too close to Dafred, trigger alert i.e. set all ronin to brainhunt
	if triggeralert and not self.AlertTriggered then
		self.AlertTriggered = true;
		
		for actor in MovableMan.Actors do
			if actor.Team == self.CPUTeam and actor.PresetName ~= "Dafred" and actor.ClassName == "AHuman" then
				actor.AIMode = Actor.AIMODE_BRAINHUNT;
			end
		end
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Excavation:AdvanceToCapture()
	--print ("AdvanceToCapture")

	local pos = nil;

	if MovableMan:IsActor(self.RoninLeader) then
		pos = Vector(self.RoninLeader.Pos.X , self.RoninLeader.Pos.Y);
		self.RoninLeader.Pos = Vector(0, 5000);
		self.RoninLeader.Health = 0;
		self.RoninLeader.LifeTime = 1;
		self.RoninLeader = nil;
	end

	-- Spawn Ronin commander
	self.RoninLeader = CreateAHuman("Dafred" , "Ronin.rte");
	self.RoninLeader:AddInventoryItem(CreateHDFirearm("Glock" , "Ronin.rte"))
	if pos ~= nil then
		self.RoninLeader.Pos = pos;
	else
		self.RoninLeader.Pos = SceneMan.Scene:GetArea("RoninLeader"):GetCenterPoint();
	end
	self.RoninLeader.Team = self.PlayerTeam;
	self.RoninLeader.AIMode = Actor.AIMODE_SENTRY;
	self.RoninLeader.GetsHitByMOs = false;
	self.RoninLeader.HitsMOs = false;	
	MovableMan:AddActor(self.RoninLeader);--]]--
	
	self.CurrentFightPhase = self.FightPhase.CAPTURE;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Excavation:PhaseCapture()
	for player = 0, self.PlayerCount - 1 do
		FrameMan:ClearScreenText(player);
		FrameMan:SetScreenText("Get Jack to ronin leader", player, 100, 1000, true);
	end

	if MovableMan:IsActor(self.Jack) then
		self:AddObjectivePoint("Jack", self.Jack.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		
		-- Check for victory
		if MovableMan:IsActor(self.RoninLeader) then
			self.RoninLeader.Vel = Vector(0,0);
			local dist = math.sqrt((self.Jack.Pos.X - self.RoninLeader.Pos.X) ^ 2 + (self.Jack.Pos.Y - self.RoninLeader.Pos.Y) ^ 2);
			
			if dist < 100 then
				if self.ActivityState ~= Activity.OVER then
					self.WinnerTeam = self.PlayerTeam;
					ActivityMan:EndActivity();
					for player = 0, self.PlayerCount - 1 do
						self.braindead[player] = true;
						FrameMan:ClearScreenText(player);
					end
				end
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function Excavation:DoBrainSelection()
	if self.ActivityState ~= Activity.OVER then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);

			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) then
				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self.AssignedBrains[player] = newBrain;
					self:SwitchToActor(newBrain, player, team);
				end
			else
				self:SetObservationTarget(brain.Pos, player)
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Check winning conditions
-----------------------------------------------------------------------------------------
function Excavation:CheckLoser()
	if self.ActivityState ~= Activity.OVER then
	
		if MovableMan:IsActor(self.Jack) then
			if self.Jack.Health <= 0 then
				self.Jack = nil
			end
		end
		
		if MovableMan:IsActor(self.Jess) then
			if self.Jess.Health <= 0 then
				self.Jess = nil
			end
		end

		if MovableMan:IsActor(self.Lynx) then
			if self.Lynx.Health <= 0 then
				self.Lynx = nil
			end
		end

		if MovableMan:IsActor(self.RoninLeader) then
			if self.RoninLeader.Health <= 0 then
				self.RoninLeader = nil
			end
		else
			RoninLeader.Health = 100;
		end
	
		if self.Jack == nil or self.Jess == nil or self.Lynx == nil or self.RoninLeader == nil then
			for player = 0, self.PlayerCount - 1 do
				if MovableMan:IsActor(self.Jack) then
					self:SetPlayerBrain(self.Jack , player);
					self:SwitchToActor(self.Jack, player, self.PlayerTeam);
				elseif MovableMan:IsActor(self.Jess) then
					self:SetPlayerBrain(self.Jess , player);
					self:SwitchToActor(self.Jess, player, self.PlayerTeam);
				elseif MovableMan:IsActor(self.Lynx) then
					self:SetPlayerBrain(self.Lynx , player);
					self:SwitchToActor(self.Lynx, player, self.PlayerTeam);
				end
			end
		
			self.WinnerTeam = self.CPUTeam;
			ActivityMan:EndActivity();
			for player = 0, self.PlayerCount - 1 do
				self.braindead[player] = true;
				FrameMan:ClearScreenText(player);
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Triggers agressive music if some of critical actors was wounded
-----------------------------------------------------------------------------------------
function Excavation:ProcessMusic(a1,a2,a3,a4,a5)
	local actors = {}
	
	actors[1] = a1;
	actors[2] = a2;
	actors[3] = a3;
	actors[4] = a4;
	actors[5] = a5;
	
	for i = 1, 5 do
		if MovableMan:IsActor(actors[i]) then
			if actors[i].Health < self.Health[i] then
				if not self.IsAgressive then
					self.IsAgressive = true;
					self:StartMusic(self.MusicModule, self.MusicAgressive)
				end
				self.MusicTimer:Reset();
				self.Health[i] = actors[i].Health
				break;
			end
			self.Health[i] = actors[i].Health
		end
	end

	if self.IsAgressive then
		if self.MusicTimer:IsPastSimMS(self.AgressiveLength) then
			self.IsAgressive = false;
			self:StartMusic(self.MusicModule, self.MusicCalm)
		end
	end
end
-----------------------------------------------------------------------------------------
-- Starts music from file if it's installed
-----------------------------------------------------------------------------------------
function Excavation:StartMusic(modulename , musicfile)
	local path = "./"..modulename.."/"..musicfile

	if self:IsFilePathExists(path) then
		AudioMan:ClearMusicQueue();
		AudioMan:PlayMusic(path, -1, -1);
	else
		print ("Can't find music: "..path);
	end	
end
-----------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------
function Excavation:IsFilePathExists(path)
	io = require("io");
	
	local file = io.open(path , "r");
	
	if file == nil then
		return false;
	end
	
	file:close();
	return true;
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------



































