-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function Gryphon:StartActivity()
	print("START! -- Gryphon:StartActivity()!");

	-- Music related variables
	self.MusicTimer = Timer()
	self.AgressiveLength = 10000
	self.IsAgressive = false
	self.IsStarted = false
	self.MusicCalm = "Next Day (calm).ogg"
	self.MusicAgressive = "Next Day (agressive).ogg"
	self.MusicModule = "Missions - Earth Music.rte"
	self.Health = {}
	
	for i = 1, 5 do
		self.Health[i] = 0;
	end

	self:StartMusic(self.MusicModule, self.MusicCalm)
	-- End of music related variables
	
	
	self.braindead = {};
	self.AssignedBrains = {};

	self.MOIDLimit = 220;

	self.PlayerGold = 500;

   	self.CPUTeam = Activity.TEAM_2;
	self.PlayerTeam = Activity.TEAM_1;
	self.RogueTeam = -1;

	self.FightPhase = {NOFIGHT  = 1 , DOWNLOAD = 2, EVACUATE = 3}
	self.CurrentFightPhase = self.FightPhase.NOFIGHT;
	
	self.LWepList = {"Peacemaker" , "Glock" , "Desert Eagle" , "Uzi" , "Shortgun"};
	self.HWepList = {"M16" , "AK-47" , "M1 Garand" , "Pumpgun", "Spas 12" , "Kar98" , "M60"};
	self.EnemyList = {"Mia" , "Dimitri" , "Sandra" , "Gordon"};
	self.EnemyModule = "Ronin.rte";

	self.ArmorProbability = 0.35
	self.HeavyWeaponProbability = 0.3
	
	-- Difficulty related variables
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.LWepList = {"Peacemaker" , "Glock" , "Desert Eagle" };
		self.WepList = {"Pumpgun"};
		self.HWepList = {"Spas 12"};
		self.PositiveIndex = 1.5;
		self.NegativeIndex = 0.5;
		self.ArmorProbability = 0
		self.HeavyWeaponProbability = 0.1
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.LWepList = {"Peacemaker" , "Glock" , "Desert Eagle" , "Shortgun"};
		self.WepList = {"AK-47" , "Pumpgun"};
		self.HWepList = {"Spas 12"};
		self.PositiveIndex = 1.25;
		self.NegativeIndex = 0.75;
		self.ArmorProbability = 0.20
		self.HeavyWeaponProbability = 0.2
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.LWepList = {"Peacemaker", "Desert Eagle" , "Uzi" , "Shortgun"};
		self.WepList = {"AK-47" , "M1 Garand" , "Pumpgun"};
		self.HWepList = {"Spas 12" , "Kar98"};
		self.PositiveIndex = 1.0;
		self.NegativeIndex = 1.0;
		self.ArmorProbability = 0.35
		self.HeavyWeaponProbability = 0.3
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.LWepList = {"Peacemaker" , "Uzi" };
		self.WepList = {"M16" , "AK-47" , "M1 Garand"};
		self.HWepList = {"Spas 12" , "Kar98" , "M60"};
		self.PositiveIndex = 0.85;
		self.NegativeIndex = 1.15;
		self.ArmorProbability = 0.45
		self.HeavyWeaponProbability = 0.4
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.LWepList = {"Uzi"};
		self.WepList = {"M16" , "M1 Garand"};
		self.HWepList = {"Kar98" , "M60"};
		self.PositiveIndex = 0.70;
		self.NegativeIndex = 1.3;
		self.ArmorProbability = 0.55
		self.HeavyWeaponProbability = 0.5
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self.LWepList = {"Uzi"};
		self.WepList = {"M16"};
		self.HWepList = {"Kar98" , "M60", "RPG-7"};
		self.PositiveIndex = 0.55;
		self.NegativeIndex = 1.45;
		self.ArmorProbability = 0.65
		self.HeavyWeaponProbability = 0.6
	end	
	
	-- We cant't add areas in the loop because CC will never find a suitable location 
	-- for our activity
	self.GenericTimer = Timer();
	self.GenericTimer:Reset();

	self.DropZones = {};
	self.DropZones[1] = SceneMan.Scene:GetArea("DropZone1");
	self.DropZones[2] = SceneMan.Scene:GetArea("DropZone2");
	self.DropZones[3] = SceneMan.Scene:GetArea("DropZone3");
	self.DropZones[4] = SceneMan.Scene:GetArea("DropZone4");
	self.DropZones[5] = SceneMan.Scene:GetArea("DropZone5");
	self.DropZones[6] = SceneMan.Scene:GetArea("DropZone6");
	
	self.Cockpit = SceneMan.Scene:GetArea("Cockpit");
	self.Ship = SceneMan.Scene:GetArea("Ship");
	self.Emission = SceneMan.Scene:GetArea("Engines");
	self.EmissionMoveInterval = 200;

    self.EmissionTimer = Timer();
    self.EmissionTimer:Reset();

    self.Emitters = {};
    self.EmitterCount = 21;
    for i = 0 , self.EmitterCount do
		self.Emitters[i] = CreateAEmitter("Warship Engine" , "Missions - Earth.rte");
		self.Emitters[i].Pos = self.Emission:GetRandomPoint();
		self.Emitters[i].RotAngle = math.rad(270);
		self.Emitters[i]:EnableEmission(true);
		MovableMan:AddParticle(self.Emitters[i]);
    end
	
	self.Download = SceneMan.Scene:GetArea("Download");
	self.DownloadStarted = false;
	
	self.ChunksDownloaded = 0;
	self.ChunkInterval = ((60000 * self.NegativeIndex)  / 100); -- Change 60000 to something else if you want longer download time
	
	self.DownloadTimer = Timer();
	self.DownloadTimer:Reset();
	
    self.SpawnTimer = Timer();
    self.SpawnTimer:Reset();
	self.SpawnInterval = 6000 * self.PositiveIndex;
	self.SpawnPosition = 1;
	self.SpawnCount = 1;
	self.MaxSpawnCount = 14 * self.NegativeIndex; -- How many ronin dropships to spawn
	
	--Spawn Our Heroes
	self.Jack = CreateAHuman("Jack" , "UniTec.rte");
	self.Jack.Team = self.PlayerTeam;
	self.Jack:AddInventoryItem(CreateHDFirearm("Franchi SPAS-15" , "UniTec.rte"));
	self.Jack.AIMode = Actor.AIMODE_SENTRY;
	self.Jack.Pos = SceneMan.Scene:GetArea("Jack"):GetCenterPoint();
	for player = 0, self.PlayerCount - 1 do
		self:SetPlayerBrain(self.Jack, player);
		self:SwitchToActor(self.Jack, player, self.PlayerTeam);
	end
	MovableMan:AddActor(self.Jack);

	self.Gus = CreateAHuman("Brain Gus" , "UniTec.rte");
	self.Gus.Team = self.PlayerTeam;
	self.Gus:AddInventoryItem(CreateHDFirearm("Colt M16" , "UniTec.rte"));
	self.Gus.AIMode = Actor.AIMODE_SENTRY;
	self.Gus.Pos = SceneMan.Scene:GetArea("Gus"):GetCenterPoint();
	MovableMan:AddActor(self.Gus);
	
	self.Tanya = CreateAHuman("Brain Tanya" , "UniTec.rte");
	self.Tanya.Team = self.PlayerTeam;
	self.Tanya:AddInventoryItem(CreateHDFirearm("AI AWM" , "UniTec.rte"));
	self.Tanya.AIMode = Actor.AIMODE_SENTRY;
	self.Tanya.Pos = SceneMan.Scene:GetArea("Tanya"):GetCenterPoint();
	MovableMan:AddActor(self.Tanya);

	self.Jess = CreateAHuman("Brain Jess" , "UniTec.rte");
	self.Jess.Team = self.PlayerTeam;
	self.Jess:AddInventoryItem(CreateHDFirearm("HK MP5K" , "UniTec.rte"));
	self.Jess.AIMode = Actor.AIMODE_SENTRY;
	self.Jess.Pos = SceneMan.Scene:GetArea("Jess"):GetCenterPoint();
	MovableMan:AddActor(self.Jess);
	
	self:SetTeamFunds(0 , self.PlayerTeam);
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
-- This function is called when mission is paused
function Gryphon:PauseActivity(pause)
    print("PAUSE! -- Gryphon:PauseActivity()!");
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
-- This function is called after mission has ended
function Gryphon:EndActivity()
    print("END! -- Gryphon:EndActivity()!");
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Gryphon:SpawnEnemy()
	-- Spawn ordinary enemy
	if self.SpawnCount < self.MaxSpawnCount then
		if MovableMan:GetMOIDCount() <= self.MOIDLimit then
			if self.SpawnTimer:IsPastSimMS(self.SpawnInterval) then
				local ship;
				
				ship = CreateACDropShip("Drop Ship MK1" , "Base.rte");
				ship.Team = self.CPUTeam;
				ship.Pos = Vector(self.DropZones[self.SpawnPosition]:GetCenterPoint().X, -20);
				ship:SetControllerMode(Controller.CIM_AI, -1);

				for i = 1 , 2 do
					local actor;

					if math.random() < self.ArmorProbability then
						actor = CreateAHuman("Brutus" , self.EnemyModule);
						actor:AddInventoryItem(CreateHeldDevice("Riot Shield" , self.EnemyModule))
						actor:AddInventoryItem(CreateHDFirearm("Uzi" , self.EnemyModule))
					else
						actor = CreateAHuman(self.EnemyList[math.random(#self.EnemyList)] , self.EnemyModule);
						if math.random() < self.HeavyWeaponProbability then
							actor:AddInventoryItem(CreateHDFirearm(self.HWepList[math.random(#self.HWepList)] , self.EnemyModule))
						else
							actor:AddInventoryItem(CreateHDFirearm(self.LWepList[math.random(#self.LWepList)] , self.EnemyModule))
						end
					end
					actor.Team = self.CPUTeam; -- Gameplay
					actor.AIMode = Actor.AIMODE_BRAINHUNT;
					ship:AddInventoryItem(actor);
				end

				MovableMan:AddActor(ship);

				-- Move to next position regardless of spawn success or failure
				self.SpawnPosition = self.SpawnPosition + 1;
			
				-- Looped through all position, spawn complete
				if self.SpawnPosition > #self.DropZones then
					self.SpawnPosition = 1
				end
				
				self.SpawnCount = self.SpawnCount + 1;
				self.SpawnTimer:Reset();
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Emit engine glows
-----------------------------------------------------------------------------------------
function Gryphon:DoEmission()
	if self.EmissionTimer:IsPastSimMS(self.EmissionMoveInterval) then
		for i = 0 , self.EmitterCount do
			self.Emitters[i].Pos = self.Emission:GetRandomPoint();
		end
		self.EmissionTimer:Reset();
	end
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function Gryphon:UpdateActivity()
   	self:ClearObjectivePoints();
	
	self:ProcessMusic(self.Jack, self.Gus, self.Tanya, self.Jess, nil)
	
	if self.CurrentFightPhase == self.FightPhase.NOFIGHT then
		self:PhaseNoFight();
	elseif self.CurrentFightPhase == self.FightPhase.DOWNLOAD then
		self:PhaseDownload();
	elseif self.CurrentFightPhase == self.FightPhase.EVACUATE then
		self:PhaseEvacuate();
	end
	
	self:CheckLoser();
	self:DoEmission();
	self:DoBrainSelection()
	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Gryphon:PhaseNoFight()
	-- Control ship
	if MovableMan:IsActor(self.HeroShip) then
		for player = 0, self.PlayerCount - 1 do
			self:SetObservationTarget(self.HeroShip.Pos, player);
		end
		self.HeroShip:SetControllerMode(Controller.CIM_AI, -1);
	end	

	-- Show heroes marks
	if not self.GenericTimer:IsPastSimMS(4000) then
		if MovableMan:IsActor(self.Jack) then
			self:AddObjectivePoint("Jack", self.Jack.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end

		if MovableMan:IsActor(self.Gus) then
			self:AddObjectivePoint("Gus", self.Gus.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
		
		if MovableMan:IsActor(self.Tanya) then
			self:AddObjectivePoint("Tanya", self.Tanya.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end

		if MovableMan:IsActor(self.Jess) then
			self:AddObjectivePoint("Jess", self.Jess.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	else
		self:AdvanceToDownload();
	end

	for player = 0, self.PlayerCount - 1 do
		FrameMan:ClearScreenText(player);
		FrameMan:SetScreenText("Download data from terminal\nScarlett's life depends on you!\nKeep your buddies alive!!!", player, -1, 1000, true);
	end
	
	-- Kill all targets
	--for actor in MovableMan.Actors do
	--	if actor.Team == self.CPUTeam and actor.PresetName ~= "Dafred" and actor.ClassName == "AHuman" then
	-- 		actor.Health = actor.Health - math.random();
	--	end
	--end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Gryphon:AdvanceToDownload()
	print ("AdvanceToDownload")
	self:SetTeamFunds(self.PlayerGold , self.PlayerTeam);
	
	self.SpawnTimer:Reset();
	self.GenericTimer:Reset();
	self.CurrentFightPhase = self.FightPhase.DOWNLOAD;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Gryphon:PhaseDownload()
	if self.DownloadStarted then
		if not self.GenericTimer:IsPastSimMS(5000) then
			for player = 0, self.PlayerCount - 1 do
				FrameMan:ClearScreenText(player);
				FrameMan:SetScreenText("It's a trap!!! Incoming Ronin dropships!!!", player, 250, 500, true);
			end
		end
	
		self:SpawnEnemy();
	end
	
	-- Check if our actors inside download area
	local inside = false;
	local pos = self.Download:GetCenterPoint() + Vector(0, -20);
	
	if MovableMan:IsActor(self.Jack) then
		if self.Download:IsInside(self.Jack.Pos) then
			inside = true;
		end
	end

	if MovableMan:IsActor(self.Gus) then
		if self.Download:IsInside(self.Gus.Pos) then
			inside = true;
		end
	end
	
	if MovableMan:IsActor(self.Tanya) then
		if self.Download:IsInside(self.Tanya.Pos) then
			inside = true;
		end
	end

	if MovableMan:IsActor(self.Jess) then
		if self.Download:IsInside(self.Jess.Pos) then
			inside = true;
		end
	end
	
	if inside then
		if not self.DownloadStarted then
			self.GenericTimer:Reset();
			self.SpawnTimer:Reset();
		end

		self.DownloadStarted = true;
	
		if self.DownloadTimer:IsPastSimMS(self.ChunkInterval) then
			self.ChunksDownloaded = self.ChunksDownloaded + 1;
		
			self.DownloadTimer:Reset();
		end
		
		self:AddObjectivePoint("Downloading "..tostring(self.ChunksDownloaded).."%", pos, self.PlayerTeam, GameActivity.ARROWDOWN);
	else
		self.DownloadTimer:Reset();
		self.ChunksDownloaded = 0;
		self:AddObjectivePoint("Download\ndata", pos, self.PlayerTeam, GameActivity.ARROWDOWN);
	end
	
	if self.ChunksDownloaded == 100 then
		self:AdvanceToEvacuate();
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Gryphon:AdvanceToEvacuate()
	print ("AdvanceToEvacuate")
	self.GenericTimer:Reset();
	
	self.SpawnCount = 1;
	self.MaxSpawnCount = 4; -- How many ronin dropships to spawn
	
	self.CurrentFightPhase = self.FightPhase.EVACUATE;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Gryphon:PhaseEvacuate()
	-- Write objectives
	if not self.GenericTimer:IsPastSimMS(5000) then
		for player = 0, self.PlayerCount - 1 do
			FrameMan:ClearScreenText(player);
			FrameMan:SetScreenText("Now get to the cockpit and escape!!!", player, 250, 500, true);
		end
	end

	local enemies = 0;
	
	for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam then
			if self.Ship:IsInside(actor.Pos) then
				enemies = enemies + 1;
				self:AddObjectivePoint("Kill", actor.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			end
		end
	end
	
	-- Tell heroes to get the hell out of core chamber
	local evacuated = 0;
	
	-- Check for victory
	if MovableMan:IsActor(self.Jack) then
		if self.Cockpit:IsInside(self.Jack.Pos) then
			self:AddObjectivePoint("Safe", self.Jack.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			evacuated = evacuated + 1;
		end
	end

	if MovableMan:IsActor(self.Gus) then
		if self.Cockpit:IsInside(self.Gus.Pos) then
			self:AddObjectivePoint("Safe", self.Gus.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			evacuated = evacuated + 1;
		end
	end
	
	if MovableMan:IsActor(self.Tanya) then
		if self.Cockpit:IsInside(self.Tanya.Pos) then
			self:AddObjectivePoint("Safe", self.Tanya.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			evacuated = evacuated + 1;
		end
	end

	if MovableMan:IsActor(self.Jess) then
		if self.Cockpit:IsInside(self.Jess.Pos) then
			self:AddObjectivePoint("Safe", self.Jess.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			evacuated = evacuated + 1;
		end
	end

	if evacuated == 3 then
		self:SpawnEnemy();
	end
	
	if evacuated == 4 and enemies == 0 then
		if self.ActivityState ~= Activity.OVER then
			self.Evacuated = true;
			self.WinnerTeam = self.PlayerTeam;
			ActivityMan:EndActivity();
			for player = 0, self.PlayerCount - 1 do
				self.braindead[player] = true;
				FrameMan:ClearScreenText(player);
			end
		end	
	end
	
	self:AddObjectivePoint("Escape!!!", self.Cockpit:GetCenterPoint(), self.PlayerTeam, GameActivity.ARROWDOWN);
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function Gryphon:DoBrainSelection()
	if self.ActivityState ~= Activity.OVER then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);

			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) then
				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self.AssignedBrains[player] = newBrain;
					self:SwitchToActor(newBrain, player, team);
				end
			else
				self:SetObservationTarget(brain.Pos, player)
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Check winning conditions
-----------------------------------------------------------------------------------------
function Gryphon:CheckLoser()
	if self.ActivityState ~= Activity.OVER then
		if MovableMan:IsActor(self.Jack) then
			if self.Jack.Health <= 0 then
				self.Jack = nil
			end
		end
		
		if MovableMan:IsActor(self.Jess) then
			if self.Jess.Health <= 0 then
				self.Jess = nil
			end
		end

		if MovableMan:IsActor(self.Tanya) then
			if self.Tanya.Health <= 0 then
				self.Tanya = nil
			end
		end

		if MovableMan:IsActor(self.Gus) then
			if self.Gus.Health <= 0 then
				self.Gus = nil
			end
		end
		
		if self.Jack == nil or self.Jess == nil or self.Tanya == nil or self.Gus == nil then
			for player = 0, self.PlayerCount - 1 do
				if MovableMan:IsActor(self.Jack) then
					self:SetPlayerBrain(self.Jack , player);
					self:SwitchToActor(self.Jack, player, self.PlayerTeam);
				elseif MovableMan:IsActor(self.Jess) then
					self:SetPlayerBrain(self.Jess , player);
					self:SwitchToActor(self.Jess, player, self.PlayerTeam);
				elseif MovableMan:IsActor(self.Tanya) then
					self:SetPlayerBrain(self.Tanya , player);
					self:SwitchToActor(self.Tanya, player, self.PlayerTeam);
				elseif MovableMan:IsActor(self.Gus) then
					self:SetPlayerBrain(self.Gus , player);
					self:SwitchToActor(self.Gus, player, self.PlayerTeam);
				end
			end
		
			self.WinnerTeam = self.CPUTeam;
			ActivityMan:EndActivity();
			for player = 0, self.PlayerCount - 1 do
				self.braindead[player] = true;
				FrameMan:ClearScreenText(player);
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Triggers agressive music if some of critical actors was wounded
-----------------------------------------------------------------------------------------
function Gryphon:ProcessMusic(a1,a2,a3,a4,a5)
	local actors = {}
	
	actors[1] = a1;
	actors[2] = a2;
	actors[3] = a3;
	actors[4] = a4;
	actors[5] = a5;
	
	for i = 1, 5 do
		if MovableMan:IsActor(actors[i]) then
			if actors[i].Health < self.Health[i] then
				if not self.IsAgressive then
					self.IsAgressive = true;
					self:StartMusic(self.MusicModule, self.MusicAgressive)
				end
				self.MusicTimer:Reset();
				self.Health[i] = actors[i].Health
				break;
			end
			self.Health[i] = actors[i].Health
		end
	end

	if self.IsAgressive then
		if self.MusicTimer:IsPastSimMS(self.AgressiveLength) then
			self.IsAgressive = false;
			self:StartMusic(self.MusicModule, self.MusicCalm)
		end
	end
end
-----------------------------------------------------------------------------------------
-- Starts music from file if it's installed
-----------------------------------------------------------------------------------------
function Gryphon:StartMusic(modulename , musicfile)
	local path = "./"..modulename.."/"..musicfile

	if self:IsFilePathExists(path) then
		AudioMan:ClearMusicQueue();
		AudioMan:PlayMusic(path, -1, -1);
	else
		print ("Can't find music: "..path);
	end	
end
-----------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------
function Gryphon:IsFilePathExists(path)
	io = require("io");
	
	local file = io.open(path , "r");
	
	if file == nil then
		return false;
	end
	
	file:close();
	return true;
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------



































