-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function OldDam:StartActivity()
	print("START! -- OldDam:StartActivity()!");

	-- Music related variables
	self.MusicTimer = Timer()
	self.AgressiveLength = 10000
	self.IsAgressive = false
	self.IsStarted = false
	self.MusicCalm = "Technical Phobia (calm).ogg"
	self.MusicAgressive = "RTS (agressive).ogg"
	self.MusicModule = "Missions - Earth Music.rte"
	self.Health = {}
	
	for i = 1, 5 do
		self.Health[i] = 0;
	end

	self:StartMusic(self.MusicModule, self.MusicCalm)
	-- End of music related variables

	self.braindead = {};
	self.AssignedBrains = {};

	self.MOIDLimit = 220;

	self.PlayerGold = 500;

   	self.CPUTeam = Activity.TEAM_2;
	self.PlayerTeam = Activity.TEAM_1;
	self.RogueTeam = -1;

	self.FightPhase = {NOFIGHT  = 1 , REACH = 2, DEFEND = 3}
	self.CurrentFightPhase = self.FightPhase.NOFIGHT;
	
	self.LWepList = {"Peacemaker" , "Glock" , "Desert Eagle" , "Uzi" , "Shortgun"};
	self.HWepList = {"M16" , "AK-47" , "M1 Garand" , "Pumpgun", "Spas 12" , "Kar98" , "M60"};
	self.EnemyList = {"Mia" , "Dimitri" , "Sandra" , "Gordon"};
	self.EnemyModule = "Ronin.rte";

	self.ArmorProbability = 0.35
	self.HeavyWeaponProbability = 0.3
	
	-- Difficulty related variables
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.LWepList = {"Peacemaker" , "Glock" , "Desert Eagle" };
		self.WepList = {"Pumpgun"};
		self.HWepList = {"Spas 12"};
		self.PositiveIndex = 1.5;
		self.NegativeIndex = 0.5;
		self.ArmorProbability = 0
		self.HeavyWeaponProbability = 0.1
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.LWepList = {"Peacemaker" , "Glock" , "Desert Eagle" , "Shortgun"};
		self.WepList = {"AK-47" , "Pumpgun"};
		self.HWepList = {"Spas 12"};
		self.PositiveIndex = 1.25;
		self.NegativeIndex = 0.75;
		self.ArmorProbability = 0.20
		self.HeavyWeaponProbability = 0.2
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.LWepList = {"Peacemaker", "Desert Eagle" , "Uzi" , "Shortgun"};
		self.WepList = {"AK-47" , "M1 Garand" , "Pumpgun"};
		self.HWepList = {"Spas 12" , "Kar98"};
		self.PositiveIndex = 1.0;
		self.NegativeIndex = 1.0;
		self.ArmorProbability = 0.35
		self.HeavyWeaponProbability = 0.3
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.LWepList = {"Peacemaker" , "Uzi" };
		self.WepList = {"M16" , "AK-47" , "M1 Garand"};
		self.HWepList = {"Spas 12" , "Kar98" , "M60"};
		self.PositiveIndex = 0.85;
		self.NegativeIndex = 1.15;
		self.ArmorProbability = 0.45
		self.HeavyWeaponProbability = 0.4
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.LWepList = {"Uzi"};
		self.WepList = {"M16" , "M1 Garand"};
		self.HWepList = {"Kar98" , "M60"};
		self.PositiveIndex = 0.70;
		self.NegativeIndex = 1.3;
		self.ArmorProbability = 0.55
		self.HeavyWeaponProbability = 0.5
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self.LWepList = {"Uzi"};
		self.WepList = {"M16"};
		self.HWepList = {"Kar98" , "M60", "RPG-7"};
		self.PositiveIndex = 0.55;
		self.NegativeIndex = 1.45;
		self.ArmorProbability = 0.65
		self.HeavyWeaponProbability = 0.6
	end		
	
	-- We cant't add areas in the loop because CC will never find a suitable location 
	-- for our activity
	self.GenericTimer = Timer();
	self.GenericTimer:Reset();

	self.WaitTimer = Timer();
	self.WaitTimer:Reset();

	self.SpawnTimer = Timer();
	self.SpawnTimer:Reset();

	self.SpawnDelayTimer = Timer();
	self.SpawnDelayTimer:Reset();
	self.SpawnDelayInterval = 100;
	
	self.ChunksComplete = 0;
	self.ChunksNeeded = 60 * 5 * self.NegativeIndex; -- Seconds * minutes
	self.ChunkInterval = 1000;
	
	-- In this mission we'll use alternative spawn method. We won't spawn enemies while
	-- activity isn't started, we'll start spawning when activity plays, by one or two actors every frame
	-- The problem is when we spawn troops with dead activity, it does not count MOIDs until they are
	-- placed on the battlefield. And we always have more randomly populated spawn points then available actors.
	-- So in some cases we may accidentally hit the MOID limit which is the same as crash but much worse
	-- This flag indicates that we used all MOIDs for actors or passed through all enemy positions.
	self.SpawnComplete = false;
	
	-- Position for wich we're trying to spawn actor
	self.SpawnPosition = 1;	

	self.ControlRoom = SceneMan.Scene:GetArea("ControlRoom");
	
	-- We cant't add areas in the loop because CC will never find a suitable location 
	-- for our activity
	self.Enemy = {}
	self.Enemy[1] = SceneMan.Scene:GetArea("Enemy1");
	self.Enemy[2] = SceneMan.Scene:GetArea("Enemy2");
	self.Enemy[3] = SceneMan.Scene:GetArea("Enemy3");
	self.Enemy[4] = SceneMan.Scene:GetArea("Enemy4");
	self.Enemy[5] = SceneMan.Scene:GetArea("Enemy5");
	self.Enemy[6] = SceneMan.Scene:GetArea("Enemy6");
	self.Enemy[7] = SceneMan.Scene:GetArea("Enemy7");
	self.Enemy[8] = SceneMan.Scene:GetArea("Enemy8");
	self.Enemy[9] = SceneMan.Scene:GetArea("Enemy9");
	self.Enemy[10] = SceneMan.Scene:GetArea("Enemy10");	
	self.Enemy[11] = SceneMan.Scene:GetArea("Enemy11");
	self.Enemy[12] = SceneMan.Scene:GetArea("Enemy12");
	self.Enemy[13] = SceneMan.Scene:GetArea("Enemy13");
	self.Enemy[14] = SceneMan.Scene:GetArea("Enemy14");
	self.Enemy[15] = SceneMan.Scene:GetArea("Enemy15");
	self.Enemy[16] = SceneMan.Scene:GetArea("Enemy16");
	self.Enemy[17] = SceneMan.Scene:GetArea("Enemy17");
	self.Enemy[18] = SceneMan.Scene:GetArea("Enemy18");
	
	self.DropZones = {};
	self.DropZones[1] = SceneMan.Scene:GetArea("DropZone1");
	self.DropZones[2] = SceneMan.Scene:GetArea("DropZone2");
	self.DropZones[3] = SceneMan.Scene:GetArea("DropZone3");
	self.DropZones[4] = SceneMan.Scene:GetArea("DropZone4");
	self.DropZones[5] = SceneMan.Scene:GetArea("DropZone5");
	self.DropZones[6] = SceneMan.Scene:GetArea("DropZone6");


	self.Bridges = {};
	self.Bridges[1] = SceneMan.Scene:GetArea("Bridge1");
	self.Bridges[2] = SceneMan.Scene:GetArea("Bridge2");
	self.Bridges[3] = SceneMan.Scene:GetArea("Bridge3");
	self.Bridges[4] = SceneMan.Scene:GetArea("Bridge4");
	self.Bridges[5] = SceneMan.Scene:GetArea("Bridge5");
	self.Bridges[6] = SceneMan.Scene:GetArea("Bridge6");
	
    self.SpawnTimer = Timer();
    self.SpawnTimer:Reset();
	self.SpawnInterval = 5000;
	self.SpawnPosition = 1;
	self.SpawnWave = 0;
	self.LastZombieSpawnWave = 2;
	
	--Spawn Our Heroes
	self.Grizzly = CreateAHuman("Brain Grizzly" , "UniTec.rte");
	self.Grizzly.Team = self.PlayerTeam;
	self.Grizzly:AddInventoryItem(CreateHDFirearm("RPG-27" , "UniTec.rte"));
	self.Grizzly.AIMode = Actor.AIMODE_SENTRY;
	-- self.Grizzly.Pos = Vector(1500, 1200); -- Debug
	-- self.Grizzly.Pos = Vector(1500, 1300); -- Debug
	for player = 0, self.PlayerCount - 1 do
		self:SetPlayerBrain(self.Grizzly, player);
		self:SwitchToActor(self.Grizzly, player, self.PlayerTeam);
	end
	-- MovableMan:AddActor(self.Grizzly); -- Debug

	self.Cougar = CreateAHuman("Brain Cougar" , "UniTec.rte");
	self.Cougar.Team = self.PlayerTeam;
	self.Cougar:AddInventoryItem(CreateHDFirearm("HK 21" , "UniTec.rte"));
	self.Cougar.AIMode = Actor.AIMODE_SENTRY;
	
	self.Tanya = CreateAHuman("Brain Tanya" , "UniTec.rte");
	self.Tanya.Team = self.PlayerTeam;
	self.Tanya:AddInventoryItem(CreateHDFirearm("AI AWM" , "UniTec.rte"));
	self.Tanya.AIMode = Actor.AIMODE_SENTRY;

	self.Jess = CreateAHuman("Brain Jess" , "UniTec.rte");
	self.Jess.Team = self.PlayerTeam;
	self.Jess:AddInventoryItem(CreateHDFirearm("HK MP5K" , "UniTec.rte"));
	self.Jess.AIMode = Actor.AIMODE_SENTRY;
	
	self.HeroShip = CreateACDropShip("UniTec Drop Ship" , "Unitec.rte");
	self.HeroShip.Team = self.PlayerTeam;
	self.HeroShip:AddInventoryItem(self.Grizzly); -- Gameplay
	self.HeroShip:AddInventoryItem(self.Cougar);
	self.HeroShip.Pos = Vector(SceneMan.Scene:GetArea("TeamDropZone"):GetCenterPoint().X + 240 , 20);
	self.HeroShip:SetControllerMode(Controller.CIM_AI, -1);
	MovableMan:AddActor(self.HeroShip);	


	self.HeroShip2 = CreateACDropShip("UniTec Drop Ship" , "Unitec.rte");
	self.HeroShip2.Team = self.PlayerTeam;
	self.HeroShip2:AddInventoryItem(self.Tanya);
	self.HeroShip2:AddInventoryItem(self.Jess);
	self.HeroShip2.Pos = Vector(SceneMan.Scene:GetArea("TeamDropZone"):GetCenterPoint().X , -40);
	self.HeroShip2:SetControllerMode(Controller.CIM_AI, -1);
	MovableMan:AddActor(self.HeroShip2);	
	
	self:SetTeamFunds(0 , self.PlayerTeam);
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
-- This function is called when mission is paused
function OldDam:PauseActivity(pause)
    print("PAUSE! -- OldDam:PauseActivity()!");
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
-- This function is called after mission has ended
function OldDam:EndActivity()
    print("END! -- OldDam:EndActivity()!");
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function OldDam:SpawnEnemyOnStart()
	local actor;
	-- Spawn ordinary enemy
	if not self.SpawnComplete then
		if MovableMan:GetMOIDCount() <= self.MOIDLimit then
			if math.random() < 0.7 then
				actor = CreateAHuman(self.EnemyList[math.random(#self.EnemyList)] , self.EnemyModule);
				--if math.random() < self.HeavyWeaponProbability then
				--	actor:AddInventoryItem(CreateHDFirearm(self.HWepList[math.random(#self.HWepList)] , self.EnemyModule))
				--else
					actor:AddInventoryItem(CreateHDFirearm(self.LWepList[math.random(#self.LWepList)] , self.EnemyModule))
				--end
				actor.Pos = self.Enemy[self.SpawnPosition]:GetCenterPoint();
				actor.Team = self.CPUTeam; -- Gameplay
				--actor.Team = self.PlayerTeam; -- Debug
				actor.AIMode = Actor.AIMODE_SENTRY;

				if self.SpawnPosition == 1 or self.SpawnPosition == 3 or self.SpawnPosition == 4 or 
				self.SpawnPosition == 6 or self.SpawnPosition == 7 or self.SpawnPosition == 9 or 
				self.SpawnPosition == 14 or self.SpawnPosition == 16 then
					actor.HFlipped = true
				end				
				
				MovableMan:AddActor(actor);
			end
			-- Move to next position regardless of spawn success or failure
			self.SpawnPosition = self.SpawnPosition + 1;
			
			-- Looped through all position, spawn complete
			if self.SpawnPosition > #self.Enemy then
				self.SpawnComplete = true;
			end
		else
			self.SpawnComplete = true;
		end
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function OldDam:SpawnEnemy()
	-- Spawn ordinary enemy
	if MovableMan:GetMOIDCount() <= self.MOIDLimit then
		if self.SpawnTimer:IsPastSimMS(self.SpawnInterval) and self.SpawnDelayTimer:IsPastSimMS(self.SpawnDelayInterval) then
			local ship;
			local troopcount;
			
			if self.SpawnWave <= self.LastZombieSpawnWave then
				ship = CreateACRocket("Drop Crate" , "Dummy.rte");
				troopcount = 1;
			else
				ship = CreateACDropShip("Drop Ship MK1" , "Base.rte");
				troopcount = 2;
				self.SpawnDelayInterval = 10000;
			end
				
			-- ship.Team = self.PlayerTeam; -- Debug
			ship.Team = self.CPUTeam;
			ship.Pos = Vector(self.DropZones[self.SpawnPosition]:GetCenterPoint().X, -20);
			ship:SetControllerMode(Controller.CIM_AI, -1);

			for i = 1 , troopcount do
				local actor;
				
				if self.SpawnWave <= self.LastZombieSpawnWave then
					actor = CreateAHuman("Zombie Thin" , "Undead.rte");
					actor:AddInventoryItem(CreateTDExplosive("Blue Bomb" , "Base.rte"))
					
					actor.AIMode = Actor.AIMODE_GOTO;
					actor:ClearAIWaypoints();
					-- actor:DrawWaypoints(true); -- Debug
					actor:AddAISceneWaypoint(self.Bridges[self.SpawnPosition]:GetCenterPoint());
				else
					if math.random() < self.ArmorProbability then
						actor = CreateAHuman("Brutus" , self.EnemyModule);
						actor:AddInventoryItem(CreateHeldDevice("Riot Shield" , self.EnemyModule))
						actor:AddInventoryItem(CreateHDFirearm("Uzi" , self.EnemyModule))
					else
						actor = CreateAHuman(self.EnemyList[math.random(#self.EnemyList)] , self.EnemyModule);
						if math.random() < self.HeavyWeaponProbability then
							actor:AddInventoryItem(CreateHDFirearm(self.HWepList[math.random(#self.HWepList)] , self.EnemyModule))
						else
							actor:AddInventoryItem(CreateHDFirearm(self.LWepList[math.random(#self.LWepList)] , self.EnemyModule))
						end
						
						if math.random() < 0.25 then
							actor:AddInventoryItem(CreateHDFirearm("Heavy Digger" , "Base.rte"))
						end
					end
					
					actor.AIMode = Actor.AIMODE_BRAINHUNT;
				end
				actor.Team = self.CPUTeam; -- Gameplay
				-- actor.Team = self.PlayerTeam; -- Debug
				ship:AddInventoryItem(actor);
			end

			MovableMan:AddActor(ship);

			-- Move to next position regardless of spawn success or failure
			self.SpawnPosition = self.SpawnPosition + 1;
		
			-- Looped through all position, spawn complete
			if self.SpawnPosition > #self.DropZones then
				self.SpawnPosition = 1
				self.SpawnDelayTimer:Reset();
				self.SpawnWave = self.SpawnWave + 1;
				print ("Wave: "..tostring(self.SpawnWave))
			end
			
			self.SpawnTimer:Reset();
		end
	end
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function OldDam:UpdateActivity()
   	self:ClearObjectivePoints();
	
	self:ProcessMusic(self.Grizzly, self.Cougar, self.Tanya, self.Jess, nil)
	
	if self.CurrentFightPhase == self.FightPhase.NOFIGHT then
		self:PhaseNoFight();
	elseif self.CurrentFightPhase == self.FightPhase.REACH then
		self:PhaseReach();
	elseif self.CurrentFightPhase == self.FightPhase.DEFEND then
		self:PhaseDefend();
	end
	
	self:CheckLoser();
	self:DoBrainSelection()
	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function OldDam:PhaseNoFight()
	-- Control ship
	if MovableMan:IsActor(self.HeroShip) then
		--for player = 0, self.PlayerCount - 1 do
		--	self:SetObservationTarget(self.HeroShip.Pos, player);
		--end
		self.HeroShip:SetControllerMode(Controller.CIM_AI, -1);
	end	

	if MovableMan:IsActor(self.HeroShip2) then
		--for player = 0, self.PlayerCount - 1 do
		--	self:SetObservationTarget(self.HeroShip.Pos, player);
		--end
		self.HeroShip2:SetControllerMode(Controller.CIM_AI, -1);
	end	
	
	-- Show heroes marks
	if not self.GenericTimer:IsPastSimMS(6500) then
		if MovableMan:IsActor(self.Grizzly) then
			self:AddObjectivePoint("Grizzly", self.Grizzly.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end

		if MovableMan:IsActor(self.Cougar) then
			self:AddObjectivePoint("Cougar", self.Cougar.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
		
		if MovableMan:IsActor(self.Tanya) then
			self:AddObjectivePoint("Tanya", self.Tanya.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end

		if MovableMan:IsActor(self.Jess) then
			self:AddObjectivePoint("Jess", self.Jess.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	else
		self:AdvanceToReach();
	end

	for player = 0, self.PlayerCount - 1 do
		FrameMan:ClearScreenText(player);
		FrameMan:SetScreenText("Get to submarine control room!\nKeep your buddies alive!!!", player, -1, 1000, true);
	end
	
	self:SpawnEnemyOnStart();
	
	-- Kill all targets
	--for actor in MovableMan.Actors do
	--	if actor.Team == self.CPUTeam and actor.PresetName ~= "Dafred" and actor.ClassName == "AHuman" then
	-- 		actor.Health = actor.Health - math.random();
	--	end
	--end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function OldDam:AdvanceToReach()
	print ("AdvanceToReach")
	self:SetTeamFunds(self.PlayerGold , self.PlayerTeam);
	
	self.SpawnTimer:Reset();
	self.GenericTimer:Reset();
	self.CurrentFightPhase = self.FightPhase.REACH;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function OldDam:PhaseReach()
	-- Check if our actors inside control room area
	local inside = false;
	local pos = self.ControlRoom:GetCenterPoint() + Vector(0, -20);

	self:AddObjectivePoint("Submarine\ncontrol room", pos, self.PlayerTeam, GameActivity.ARROWDOWN);
	
	if MovableMan:IsActor(self.Grizzly) then
		if self.ControlRoom:IsInside(self.Grizzly.Pos) then
			inside = true;
		end
	end

	if MovableMan:IsActor(self.Cougar) then
		if self.ControlRoom:IsInside(self.Cougar.Pos) then
			inside = true;
		end
	end
	
	if MovableMan:IsActor(self.Tanya) then
		if self.ControlRoom:IsInside(self.Tanya.Pos) then
			inside = true;
		end
	end

	if MovableMan:IsActor(self.Jess) then
		if self.ControlRoom:IsInside(self.Jess.Pos) then
			inside = true;
		end
	end

	if inside then
		self:AdvanceToDefend();	
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function OldDam:AdvanceToDefend()
	print ("AdvanceToDefend")
	self.GenericTimer:Reset();
	self.WaitTimer:Reset();
	self.SpawnTimer:Reset();
	
	for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam then
			actor.AIMode = Actor.AIMODE_BRAINHUNT;
		end
	end
	
	self.SpawnPosition = 1;
	
	self.CurrentFightPhase = self.FightPhase.DEFEND;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function OldDam:PhaseDefend()
	-- Write objectives
	if not self.GenericTimer:IsPastSimMS(5000) then
		for player = 0, self.PlayerCount - 1 do
			FrameMan:ClearScreenText(player);
			FrameMan:SetScreenText("Enemy forces approaching!!!", player, 250, 500, true);
		end
	end
	
	local inside = false;
	local pos = self.ControlRoom:GetCenterPoint() + Vector(0, -20);
	
	if MovableMan:IsActor(self.Grizzly) then
		if self.ControlRoom:IsInside(self.Grizzly.Pos) then
			inside = true;
		end
	end

	if MovableMan:IsActor(self.Cougar) then
		if self.ControlRoom:IsInside(self.Cougar.Pos) then
			inside = true;
		end
	end
	
	if MovableMan:IsActor(self.Tanya) then
		if self.ControlRoom:IsInside(self.Tanya.Pos) then
			inside = true;
		end
	end

	if MovableMan:IsActor(self.Jess) then
		if self.ControlRoom:IsInside(self.Jess.Pos) then
			inside = true;
		end
	end
	
	self:SpawnEnemy();
	
	-- Explode zombies to destroy bridges
	for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam and actor.PresetName == "Zombie Thin" then
			for b = 1, #self.Bridges do
				if self.Bridges[b]:IsInside(actor.Pos) then
					local Charge = CreateMOSRotating("BridgeExplosion", "Missions - Earth.rte")
					Charge.Pos = actor.Pos;
					MovableMan:AddParticle(Charge)
					Charge:GibThis();
				end
			end
			
			if actor.Health < 50 then
				local Charge = CreateMOSRotating("BridgeExplosion", "Missions - Earth.rte")
				Charge.Pos = actor.Pos;
				MovableMan:AddParticle(Charge)
				Charge:GibThis();
			end
		end
	end
	
	if inside then
		if self.WaitTimer:IsPastSimMS(self.ChunkInterval) then
			self.ChunksComplete = self.ChunksComplete + 1;
			self.WaitTimer:Reset();
		end
		
		local text;
		
		text = "";
		
		local percentage = (self.ChunksComplete / self.ChunksNeeded) * 100;
		
		if percentage > 0 then
			text = "Checking systems"
		end
		
		if percentage > 20 then
			text = "Initializing life support subsystem"
		end
		
		if percentage > 40 then
			text = "Activating ship AI"
		end
		
		if percentage > 55 then
			text = "Checking AI license key"
		end
		
		if percentage > 57 then
			text = "-:::[ PATCHED BY XEON HAXXOR TEAM ]:::-"
		end
		
		if percentage > 60 then
			text = "Updating nav data"
		end
		
		if percentage > 80 then
			text = "Igniting fusion reactor"
		end
		
		if percentage > 95 then
			text = "Starting engines"
		end
		
		for p = 1, self.ChunksComplete % 4 do
			text = text.."."
		end
		
		text = text.."\nT-"..tostring(math.floor((self.ChunksNeeded - self.ChunksComplete) / 60))..":"..tostring((self.ChunksNeeded - self.ChunksComplete) % 60)
		
		if self.ChunksComplete < self.ChunksNeeded then
			self:AddObjectivePoint(text, pos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	else
		self.WaitTimer:Reset();
		self:AddObjectivePoint("Get back to control room!", pos, self.PlayerTeam, GameActivity.ARROWDOWN);
	end
	
	if self.ChunksNeeded == self.ChunksComplete then
		if self.ActivityState ~= Activity.OVER then
			self.WinnerTeam = self.PlayerTeam;
			ActivityMan:EndActivity();
			for player = 0, self.PlayerCount - 1 do
				self.braindead[player] = true;
				FrameMan:ClearScreenText(player);
			end
		end	
	end

end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function OldDam:DoBrainSelection()
	if self.ActivityState ~= Activity.OVER then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);
			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) then
				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self.AssignedBrains[player] = newBrain;
					self:SwitchToActor(newBrain, player, team);
				end
			else
				self:SetObservationTarget(brain.Pos, player)
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Check winning conditions
-----------------------------------------------------------------------------------------
function OldDam:CheckLoser()
	if self.ActivityState ~= Activity.OVER then
		if MovableMan:IsActor(self.Grizzly) then
			if self.Grizzly.Health <= 0 then
				self.Grizzly = nil
			end
		end
		
		if MovableMan:IsActor(self.Jess) then
			if self.Jess.Health <= 0 then
				self.Jess = nil
			end
		end

		if MovableMan:IsActor(self.Tanya) then
			if self.Tanya.Health <= 0 then
				self.Tanya = nil
			end
		end

		if MovableMan:IsActor(self.Cougar) then
			if self.Cougar.Health <= 0 then
				self.Cougar = nil
			end
		end
		
		if self.Grizzly == nil or self.Jess == nil or self.Tanya == nil or self.Cougar == nil then
			for player = 0, self.PlayerCount - 1 do
				if MovableMan:IsActor(self.Grizzly) then
					self:SetPlayerBrain(self.Grizzly , player);
					self:SwitchToActor(self.Grizzly, player, self.PlayerTeam);
				elseif MovableMan:IsActor(self.Jess) then
					self:SetPlayerBrain(self.Jess , player);
					self:SwitchToActor(self.Jess, player, self.PlayerTeam);
				elseif MovableMan:IsActor(self.Tanya) then
					self:SetPlayerBrain(self.Tanya , player);
					self:SwitchToActor(self.Tanya, player, self.PlayerTeam);
				elseif MovableMan:IsActor(self.Cougar) then
					self:SetPlayerBrain(self.Cougar , player);
					self:SwitchToActor(self.Cougar, player, self.PlayerTeam);
				end
			end
		
			self.WinnerTeam = self.CPUTeam;
			ActivityMan:EndActivity();
			for player = 0, self.PlayerCount - 1 do
				self.braindead[player] = true;
				FrameMan:ClearScreenText(player);
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Triggers agressive music if some of critical actors was wounded
-----------------------------------------------------------------------------------------
function OldDam:ProcessMusic(a1,a2,a3,a4,a5)
	local actors = {}
	
	actors[1] = a1;
	actors[2] = a2;
	actors[3] = a3;
	actors[4] = a4;
	actors[5] = a5;
	
	for i = 1, 5 do
		if MovableMan:IsActor(actors[i]) then
			if actors[i].Health < self.Health[i] then
				if not self.IsAgressive then
					self.IsAgressive = true;
					self:StartMusic(self.MusicModule, self.MusicAgressive)
				end
				self.MusicTimer:Reset();
				self.Health[i] = actors[i].Health
				break;
			end
			self.Health[i] = actors[i].Health
		end
	end

	if self.IsAgressive then
		if self.MusicTimer:IsPastSimMS(self.AgressiveLength) then
			self.IsAgressive = false;
			self:StartMusic(self.MusicModule, self.MusicCalm)
		end
	end
end
-----------------------------------------------------------------------------------------
-- Starts music from file if it's installed
-----------------------------------------------------------------------------------------
function OldDam:StartMusic(modulename , musicfile)
	local path = "./"..modulename.."/"..musicfile

	if self:IsFilePathExists(path) then
		AudioMan:ClearMusicQueue();
		AudioMan:PlayMusic(path, -1, -1);
	else
		print ("Can't find music: "..path);
	end	
end
-----------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------
function OldDam:IsFilePathExists(path)
	io = require("io");
	
	local file = io.open(path , "r");
	
	if file == nil then
		return false;
	end
	
	file:close();
	return true;
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------



































