-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function Ragnarok:StartActivity()
	print("START! -- Ragnarok:StartActivity()!");

	-- Music related variables
	self.MusicTimer = Timer()
	self.AgressiveLength = 10000
	self.IsAgressive = false
	self.IsStarted = false
	self.MusicCalm = "Tunnel (calm).ogg"
	self.MusicAgressive = "Tunnel (agressive).ogg"
	self.MusicModule = "Missions - Earth Music.rte"
	self.Health = {}
	
	for i = 1, 5 do
		self.Health[i] = 0;
	end

	self:StartMusic(self.MusicModule, self.MusicCalm)
	-- End of music related variables
	
	
	self.braindead = {};
	self.AssignedBrains = {};

	self.MOIDLimit = 220;

	self.PlayerGold = 500;

   	self.CPUTeam = Activity.TEAM_2;
	self.PlayerTeam = Activity.TEAM_1;
	self.RogueTeam = -1;

	self.FightPhase = {NOFIGHT  = 1 , DESTROY = 2, EVACUATE = 3}
	self.CurrentFightPhase = self.FightPhase.NOFIGHT;
	
	self.LWepList = {"Shotgun", "Compact Assault Rifle" , "Sniper Rifle" , "Auto Pistol" , "Heavy Pistol" };
	self.HWepList = {"Auto Shotgun", "Assault Rifle" , "Heavy Sniper Rifle" , "Uber Cannon" , "Revolver Cannon" , "Auto Cannon"}
	self.EnemyList = {"Soldier Light" , "Soldier Heavy"};	
	self.EnemyModule = "Coalition.rte";

	self.ArmorProbability = 0.1
	self.HeavyWeaponProbability = 0.3
	
	-- Difficulty related variables
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.LWepList = {"Auto Pistol" , "Heavy Pistol" };
		self.HWepList = {"Assault Rifle"}
		self.EnemyList = {"Soldier Light"};	
		self.ArmorProbability = 0
		self.HeavyWeaponProbability = 0.1
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.LWepList = {"Shotgun", "Auto Pistol" , "Heavy Pistol" };
		self.HWepList = {"Auto Shotgun", "Assault Rifle"}
		self.EnemyList = {"Soldier Light"};	
		self.ArmorProbability = 0.05
		self.HeavyWeaponProbability = 0.2
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.LWepList = {"Shotgun", "Compact Assault Rifle" , "Sniper Rifle" , "Auto Pistol" , "Heavy Pistol" };
		self.HWepList = {"Auto Shotgun", "Assault Rifle" , "Heavy Sniper Rifle"}
		self.EnemyList = {"Soldier Light" , "Soldier Heavy"};	
		self.ArmorProbability = 0.1
		self.HeavyWeaponProbability = 0.3
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.LWepList = {"Shotgun", "Compact Assault Rifle" , "Sniper Rifle" , "Heavy Pistol" };
		self.HWepList = {"Auto Shotgun", "Assault Rifle" , "Heavy Sniper Rifle" , "Revolver Cannon"}
		self.EnemyList = {"Soldier Light" , "Soldier Heavy"};	
		self.ArmorProbability = 0.15
		self.HeavyWeaponProbability = 0.4
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.LWepList = {"Shotgun", "Compact Assault Rifle" , "Sniper Rifle"};
		self.HWepList = {"Auto Shotgun", "Assault Rifle" , "Heavy Sniper Rifle" , "Revolver Cannon" , "Auto Cannon"}
		self.EnemyList = {"Soldier Heavy"};	
		self.ArmorProbability = 0.20
		self.HeavyWeaponProbability = 0.5
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self.LWepList = {"Compact Assault Rifle" , "Sniper Rifle"};
		self.HWepList = {"Auto Shotgun", "Assault Rifle" , "Heavy Sniper Rifle" , "Revolver Cannon" , "Auto Cannon"}
		self.EnemyList = {"Soldier Heavy"};	
		self.ArmorProbability = 0.25
		self.HeavyWeaponProbability = 0.6
	end
	
	-- We cant't add areas in the loop because CC will never find a suitable location 
	-- for our activity
	self.GenericTimer = Timer();
	self.GenericTimer:Reset();

	self.SpawnTimer = Timer();
	self.SpawnTimer:Reset();
	self.SpawnInterval = 60000;

	self.EmissionMoveInterval = 200;
	
	self.EnumEven = true;
	-- In this mission we'll use alternative spawn method. We won't spawn enemies while
	-- activity isn't started, we'll start spawning when activity plays, by one or two actors every frame
	-- The problem is when we spawn troops with dead activity, it does not count MOIDs until they are
	-- placed on the battlefield. And we always have more randomly populated spawn points then available actors.
	-- So in some cases we may accidentally hit the MOID limit which is the same as crash but much worse
	-- This flag indicates that we used all MOIDs for actors or passed through all enemy positions.
	self.SpawnComplete = false;
	
	-- Position for wich we're trying to spawn actor
	self.SpawnPosition = 1;

	-- We cant't add areas in the loop because CC will never find a suitable location 
	-- for our activity
	self.Enemy = {}
	self.Enemy[1] = SceneMan.Scene:GetArea("Enemy1");
	self.Enemy[2] = SceneMan.Scene:GetArea("Enemy2");
	self.Enemy[3] = SceneMan.Scene:GetArea("Enemy3");
	self.Enemy[4] = SceneMan.Scene:GetArea("Enemy4");
	self.Enemy[5] = SceneMan.Scene:GetArea("Enemy5");
	self.Enemy[6] = SceneMan.Scene:GetArea("Enemy6");
	self.Enemy[7] = SceneMan.Scene:GetArea("Enemy7");
	self.Enemy[8] = SceneMan.Scene:GetArea("Enemy8");
	self.Enemy[9] = SceneMan.Scene:GetArea("Enemy9");
	self.Enemy[10] = SceneMan.Scene:GetArea("Enemy10");
	self.Enemy[11] = SceneMan.Scene:GetArea("Enemy11");
	self.Enemy[12] = SceneMan.Scene:GetArea("Enemy12");
	self.Enemy[13] = SceneMan.Scene:GetArea("Enemy13");
	self.Enemy[14] = SceneMan.Scene:GetArea("Enemy14");
	self.Enemy[15] = SceneMan.Scene:GetArea("Enemy15");
	self.Enemy[16] = SceneMan.Scene:GetArea("Enemy16");
	self.Enemy[17] = SceneMan.Scene:GetArea("Enemy17");
	self.Enemy[18] = SceneMan.Scene:GetArea("Enemy18");
	self.Enemy[19] = SceneMan.Scene:GetArea("Enemy19");
	self.Enemy[20] = SceneMan.Scene:GetArea("Enemy20");
	self.Enemy[21] = SceneMan.Scene:GetArea("Enemy21");
	self.Enemy[22] = SceneMan.Scene:GetArea("Enemy22");
	self.Enemy[23] = SceneMan.Scene:GetArea("Enemy23");
	self.Enemy[24] = SceneMan.Scene:GetArea("Enemy24");
	self.Enemy[25] = SceneMan.Scene:GetArea("Enemy25");
	self.Enemy[26] = SceneMan.Scene:GetArea("Enemy26");
	self.Enemy[27] = SceneMan.Scene:GetArea("Enemy27");

	self.Guard = {}
	self.Guard[1] = SceneMan.Scene:GetArea("Guard1");
	self.Guard[2] = SceneMan.Scene:GetArea("Guard2");
	self.Guard[3] = SceneMan.Scene:GetArea("Guard3");
	self.Guard[4] = SceneMan.Scene:GetArea("Guard4");
	
	
	self.PatrolZones = {}; 
	self.PatrolWaypoints = {};

	self.PatrolZones[1] = SceneMan.Scene:GetArea("PatrolZone1");
	self.PatrolZones[2] = SceneMan.Scene:GetArea("PatrolZone2");
	self.PatrolZones[3] = SceneMan.Scene:GetArea("PatrolZone3");
	self.PatrolZones[4] = SceneMan.Scene:GetArea("PatrolZone4");
	self.PatrolZones[5] = SceneMan.Scene:GetArea("PatrolZone5");
	self.PatrolZones[6] = SceneMan.Scene:GetArea("PatrolZone6");
	self.PatrolZones[7] = SceneMan.Scene:GetArea("PatrolZone7");
	
	self.PatrolWaypoints[1] = {SceneMan.Scene:GetArea("PatrolPoint1L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint1R"):GetCenterPoint()};
	self.PatrolWaypoints[2] = {SceneMan.Scene:GetArea("PatrolPoint2L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint2R"):GetCenterPoint()};
	self.PatrolWaypoints[3] = {SceneMan.Scene:GetArea("PatrolPoint3L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint3R"):GetCenterPoint()};
	self.PatrolWaypoints[4] = {SceneMan.Scene:GetArea("PatrolPoint4L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint4R"):GetCenterPoint()};
	self.PatrolWaypoints[5] = {SceneMan.Scene:GetArea("PatrolPoint5L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint5R"):GetCenterPoint()};
	self.PatrolWaypoints[6] = {SceneMan.Scene:GetArea("PatrolPoint6L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint6R"):GetCenterPoint()};
	self.PatrolWaypoints[7] = {SceneMan.Scene:GetArea("PatrolPoint7L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint7R"):GetCenterPoint()};

	self.Roof = SceneMan.Scene:GetArea("Roof");
	self.Emission = SceneMan.Scene:GetArea("Engines");
	self.Warship = SceneMan.Scene:GetArea("Warship");
	self.MainCore = SceneMan.Scene:GetArea("MainCore");
	self.Evacuate = SceneMan.Scene:GetArea("Evacuate");
	self.Shake = SceneMan.Scene:GetArea("Shake");
	
    self.EmissionTimer = Timer();
    self.EmissionTimer:Reset();

    self.Emitters = {};
    self.EmitterCount = 21;
    for i = 0 , self.EmitterCount do
		self.Emitters[i] = CreateAEmitter("Warship Engine" , "Missions - Earth.rte");
		self.Emitters[i].Pos = self.Emission:GetRandomPoint();
		self.Emitters[i].RotAngle = math.rad(270);
		self.Emitters[i]:EnableEmission(true);
		MovableMan:AddParticle(self.Emitters[i]);
    end
	
	self.ExplosionTimer = Timer();
	self.ExplosionTimer:Reset();
	self.ExplosionInterval =  20000;
	self.ExplosionIntervalMax = 800;
	self.ExplosionIntervalMin = 220;
	self.SafeExplosionDistance = 250;
	
	self.CoreDetonated = false;
	self.Evacuated = false;
	
	self.LastExplosionPos = self.MainCore:GetCenterPoint();
	self.AlarmTimer = Timer();
	self.AlarmTimer:Reset();
	
	self.ShakeTimer = Timer();
	self.ShakeTimer:Reset();
	self.ShakeInterval = 35;
	self.ShakeMagnitude = 100;
	self.ShakeMagnitudeMax = 150;
	self.ShakeMagnitudeMin = 10;
	
	--Spawn Our Heroes
	self.Jack = CreateAHuman("Jack" , "UniTec.rte");
	self.Jack.Team = self.PlayerTeam;
	self.Jack:AddInventoryItem(CreateHDFirearm("Franchi SPAS-15" , "UniTec.rte"));
	self.Jack.AIMode = Actor.AIMODE_SENTRY;
	self.Jack.Pos = SceneMan.Scene:GetArea("Jack"):GetCenterPoint();
	for player = 0, self.PlayerCount - 1 do
		self:SetPlayerBrain(self.Jack, player);
		self:SwitchToActor(self.Jack, player, self.PlayerTeam);
	end
	MovableMan:AddActor(self.Jack);

	self.Tanya = CreateAHuman("Brain Tanya" , "UniTec.rte");
	self.Tanya.Team = self.PlayerTeam;
	self.Tanya:AddInventoryItem(CreateHDFirearm("AI AWM" , "UniTec.rte"));
	self.Tanya.AIMode = Actor.AIMODE_SENTRY;
	self.Tanya.Pos = SceneMan.Scene:GetArea("Tanya"):GetCenterPoint();
	MovableMan:AddActor(self.Tanya);

	self.Grizzly = CreateAHuman("Brain Grizzly" , "UniTec.rte");
	self.Grizzly.Team = self.PlayerTeam;
	self.Grizzly:AddInventoryItem(CreateHDFirearm("RPG-27" , "UniTec.rte"));
	self.Grizzly.AIMode = Actor.AIMODE_SENTRY;
	self.Grizzly.Pos = SceneMan.Scene:GetArea("Grizzly"):GetCenterPoint();
	MovableMan:AddActor(self.Grizzly);
	
	-- Spawn generator guards
	for i = 1, #self.Guard do
		actor = CreateACrab("Gatling Drone" , "Coalition.rte");
		actor.Pos = self.Guard[i]:GetCenterPoint();
		actor.Team = self.CPUTeam; -- Gameplay
		actor.AIMode = Actor.AIMODE_SENTRY;
		MovableMan:AddActor(actor);
	end
	
	self.Generators = {};
	self.GeneratorsPos = {}
	
	self:SetTeamFunds(0 , self.PlayerTeam);
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
-- This function is called when mission is paused
function Ragnarok:PauseActivity(pause)
    print("PAUSE! -- Ragnarok:PauseActivity()!");
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
-- This function is called after mission has ended
function Ragnarok:EndActivity()
    print("END! -- Ragnarok:EndActivity()!");
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Ragnarok:SpawnEnemyOnStart()
	local actor;
	-- Spawn ordinary enemy
	if not self.SpawnComplete then
		if MovableMan:GetMOIDCount() <= self.MOIDLimit then
			if math.random() < 0.6 then
				if math.random() < self.ArmorProbability then
					actor = CreateACrab("Gatling Drone" , "Coalition.rte");
				else
					-- print ("SpawnEnemy "..tostring(self.SpawnPosition))
					actor = CreateAHuman(self.EnemyList[math.random(#self.EnemyList)] , self.EnemyModule);
					if math.random() < self.HeavyWeaponProbability then
						actor:AddInventoryItem(CreateHDFirearm(self.HWepList[math.random(#self.HWepList)] , self.EnemyModule))
					else
						actor:AddInventoryItem(CreateHDFirearm(self.LWepList[math.random(#self.LWepList)] , self.EnemyModule))
					end
				end
				actor.Pos = self.Enemy[self.SpawnPosition]:GetCenterPoint();
				actor.Team = self.CPUTeam; -- Gameplay
				--actor.Team = self.PlayerTeam; -- Debug
				actor.AIMode = Actor.AIMODE_SENTRY;
				
				if self.SpawnPosition == 1 or self.SpawnPosition == 2 or self.SpawnPosition == 7 or 
				self.SpawnPosition == 8 or self.SpawnPosition == 13 or self.SpawnPosition == 15 or 
				self.SpawnPosition == 20 or self.SpawnPosition == 21 or self.SpawnPosition == 22 or 
				self.SpawnPosition == 23 or self.SpawnPosition == 24 or self.SpawnPosition == 27 or 
				self.SpawnPosition == 17 or self.SpawnPosition == 18 or self.SpawnPosition == 19 then
					actor.HFlipped = true
				end
				
				MovableMan:AddActor(actor);
			end
			-- Move to next position regardless of spawn success or failure
			self.SpawnPosition = self.SpawnPosition + 1;
			
			-- Looped through all position, spawn complete
			if self.SpawnPosition > #self.Enemy then
				self.SpawnComplete = true;
			end
		else
			self.SpawnComplete = true;
		end
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Ragnarok:IsEven(number)
	if number % 2 == 0 then
		return true;
	else
		return false;
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Ragnarok:PatrolControl()
	local unitcount = 0;

	-- Set flag to chech even or odd actors
	self.EnumEven = not self.EnumEven;
	
	-- Resend all enemy troops to closes patrol areas if alert is off
	-- Scan all patrol zones. If we have AIMODE_SENTRY troops there,
	-- GOTO them to the most far patrol point
	for actor in MovableMan.Actors do
		-- to reduce the lag at every cycle we control only odd or even actor. It would be more efficint to count actors every time, because more ID's can be odd or even but it was written some time ago when I was dumber )))
		if actor.Team == self.CPUTeam and actor.AIMode ~= Actor.AIMODE_GOTO and actor.AIMode ~= Actor.AIMODE_BRAINHUNT and actor.ClassName == "AHuman" then
			unitcount = unitcount + 1;
			if self:IsEven(unitcount) == self.EnumEven then
				for i = 1 , #self.PatrolZones do
					if self.PatrolZones[i]:IsInside(actor.Pos) then
						-- Calc distances to available patrol waypoint and send actor to the most far
						local dist1 = math.sqrt((actor.Pos.X - self.PatrolWaypoints[i][1].X) ^ 2 + (actor.Pos.Y - self.PatrolWaypoints[i][1].Y) ^ 2);
						local dist2 = math.sqrt((actor.Pos.X - self.PatrolWaypoints[i][2].X) ^ 2 + (actor.Pos.Y - self.PatrolWaypoints[i][2].Y) ^ 2);

						-- Flash white for debugging purposes
						-- Also you can spawn actor of your own team change team in IF and 
						-- enable DrawWaypoints to see where you troops were sent. VERY helpful!
						-- actor:FlashWhite(50);
						actor.AIMode = Actor.AIMODE_GOTO;
						actor:ClearAIWaypoints();
						actor:DrawWaypoints(true);
						if dist1 < dist2 then
							actor:AddAISceneWaypoint(self.PatrolWaypoints[i][2]);
						else
							actor:AddAISceneWaypoint(self.PatrolWaypoints[i][1]);
						end --if
						break;
					end -- if
				end -- for
			end -- if 
		end -- if
	end -- for		
end
-----------------------------------------------------------------------------------------
-- Calculate distance between pos1 to pos2 vectors
-----------------------------------------------------------------------------------------
function Ragnarok:Dist(pos1 , pos2)
	local avgx = pos1.X - pos2.X;
	local avgy = pos1.Y - pos2.Y;
	local curdist = math.sqrt(avgx ^ 2 + avgy ^ 2);
	return curdist;
end
-----------------------------------------------------------------------------------------
-- Return distance to the nearest mission critical actor
-----------------------------------------------------------------------------------------
function Ragnarok:NearestHeroDist(pos)
	local dist = 10000;
	local nearest = nil;
	local d = 15000;
	
	if MovableMan:IsActor(self.Jack) then
		d = self:Dist(pos, self.Jack.Pos);
	
		if d < dist then
			dist = d;
			nearest = self.Jack;
		end
	end
	
	if MovableMan:IsActor(self.Tanya) then
		d = self:Dist(pos, self.Tanya.Pos);
	
		if d < dist then
			dist = d;
			nearest = self.Tanya;
		end
	end

	if MovableMan:IsActor(self.Grizzly) then
		d = self:Dist(pos, self.Grizzly.Pos);
	
		if d < dist then
			dist = d;
			nearest = self.Grizzly;
		end
	end
	
	return dist;
end
-----------------------------------------------------------------------------------------
-- Emit engine glows
-----------------------------------------------------------------------------------------
function Ragnarok:DoEmission()
	if self.EmissionTimer:IsPastSimMS(self.EmissionMoveInterval) then
		for i = 0 , self.EmitterCount do
			if not self.CoreDetonated then
				self.Emitters[i].Pos = self.Emission:GetRandomPoint();
			else
				self.Emitters[i].Pos = self.Warship:GetRandomPoint();
			end
		end
		self.EmissionTimer:Reset();
	end
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function Ragnarok:UpdateActivity()
   	self:ClearObjectivePoints();
	
	self:ProcessMusic(self.Jack, self.Tanya, self.Grizzly, nil, nil)
	
	if self.CurrentFightPhase == self.FightPhase.NOFIGHT then
		self:PhaseNoFight();
	elseif self.CurrentFightPhase == self.FightPhase.DESTROY then
		self:PhaseDestroy();
	elseif self.CurrentFightPhase == self.FightPhase.EVACUATE then
		self:PhaseEvacuate();
	end
	
	self:CheckLoser();
	self:DoEmission();
	self:PatrolControl();
	self:DoBrainSelection()
	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Ragnarok:PhaseNoFight()
	-- Control ship
	if MovableMan:IsActor(self.HeroShip) then
		for player = 0, self.PlayerCount - 1 do
			self:SetObservationTarget(self.HeroShip.Pos, player);
		end
		self.HeroShip:SetControllerMode(Controller.CIM_AI, -1);
	end	

	-- Show heroes marks
	if not self.GenericTimer:IsPastSimMS(2000) then
		if MovableMan:IsActor(self.Jack) then
			self:AddObjectivePoint("Jack", self.Jack.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
		
		if MovableMan:IsActor(self.Tanya) then
			self:AddObjectivePoint("Tanya", self.Tanya.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end

		if MovableMan:IsActor(self.Grizzly) then
			self:AddObjectivePoint("Grizzly", self.Grizzly.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	else
		self:AdvanceToDestroy();
	end

	for player = 0, self.PlayerCount - 1 do
		FrameMan:ClearScreenText(player);
		FrameMan:SetScreenText("Destroy generators to disable the warship\nKeep your buddies alive!!!", player, -1, 1000, true);
	end
	
	-- Spawn enemies every frame until done
	self:SpawnEnemyOnStart();
	
	-- Kill all targets
	--for actor in MovableMan.Actors do
	--	if actor.Team == self.CPUTeam then
	-- 		actor.Health = actor.Health - math.random();
	--	end
	--end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Ragnarok:AdvanceToDestroy()
	print ("AdvanceToDestroy")
	self:SetTeamFunds(self.PlayerGold , self.PlayerTeam);
	
	local curgen = 1;
	
	-- Find generators
	for particle in MovableMan.Particles do
		if particle.PresetName == "Passive Generator" then 
			self.Generators[curgen] = particle;
			self.GeneratorsPos[curgen] = Vector(particle.Pos.X,particle.Pos.Y);
			curgen = curgen + 1;
		end
	end
	
	self.SpawnTimer:Reset();
	self.CurrentFightPhase = self.FightPhase.DESTROY;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Ragnarok:PhaseDestroy()
	local gensactive = 0;
	local tospawnroof = false;
	
	-- Mark generators
	for i = 1, #self.Generators do
		if MovableMan:IsParticle(self.Generators[i]) then
			gensactive = gensactive + 1;
			self:AddObjectivePoint("Destroy", self.Generators[i].Pos + Vector(0, -20), self.PlayerTeam, GameActivity.ARROWDOWN);
		else
			if self.Generators[i] ~= nil then
				--Make generator explosion
				local Charge = CreateMOSRotating("GeneratorExplosion", "Missions - Earth.rte")
				Charge.Pos = self.GeneratorsPos[i];
				MovableMan:AddParticle(Charge)
				Charge:GibThis();
			end
			
			self.Generators[i] = nil;
		end
	end
	
	-- Highlight dropships and rollers, check if player on the roof
	for actor in MovableMan.Actors do
		if actor.Team == self.PlayerTeam then
			--if self.Roof:IsInside(actor.Pos) then
				tospawnroof = true;
			--end
		else
			if actor.PresetName == "Drop Ship MK1" or actor.PresetName == "Blast Runner" then
				self:AddObjectivePoint("Danger!!!", actor.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			end
		end
	end
	
	-- Change 0 to 4 here to test final part
	if gensactive == 0 then
		self:AdvanceToEvacuate();
	end
	
	-- Spawn dropship with Blast Runner on the roof
	if tospawnroof then
		if self.SpawnTimer:IsPastSimMS(self.SpawnInterval) then
			if MovableMan:GetMOIDCount() <= self.MOIDLimit then
				print ("Spawn roller")
				local actor, ship;
				actor = CreateACrab("Blast Runner" , "Coalition.rte");
				actor.AIMode = Actor.AIMODE_GOTO;
				actor.Team = self.CPUTeam;
				
				ship = CreateACDropShip("Drop Ship MK1" , "Coalition.rte");
				ship.Team = self.CPUTeam;
				ship:AddInventoryItem(actor);
				ship.Pos = Vector(SceneMan.Scene:GetArea("Roof"):GetRandomPoint().X , -20);
				ship:SetControllerMode(Controller.CIM_AI, -1);
				MovableMan:AddActor(ship);
				
				self.SpawnTimer:Reset();
			end
		end
	end
	
	-- Just one/two generator remaining, enemies go mad
	if gensactive == 2 then
		if not self.AlertTriggered then
			self.AlertTriggered = true;
			
			for actor in MovableMan.Actors do
				if actor.Team == self.CPUTeam and actor.ClassName == "AHuman" or actor.ClassName == "ACrab" then
					actor.AIMode = Actor.AIMODE_BRAINHUNT;
				end
			end
		end
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Ragnarok:AdvanceToEvacuate()
	print ("AdvanceToEvacuate")
	
	self.ExplosionTimer:Reset();
	self.GenericTimer:Reset();

	self.EmissionMoveInterval = 1000;
	
	-- Stop engines and start smokes
    for i = 0 , self.EmitterCount do
		self.Emitters[i]:EnableEmission(false);
	end

    self.Emitters = {};
    self.EmitterCount = 10;
    for i = 0 , self.EmitterCount do
		self.Emitters[i] = CreateAEmitter("Smoke" , "Missions - Earth.rte");
		self.Emitters[i].Pos = self.Emission:GetRandomPoint();
		self.Emitters[i].RotAngle = math.rad(270);
		self.Emitters[i]:EnableEmission(true);
		MovableMan:AddParticle(self.Emitters[i]);
    end
	
	self.CurrentFightPhase = self.FightPhase.EVACUATE;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Ragnarok:PhaseEvacuate()
	-- Write objectives
	if not self.GenericTimer:IsPastSimMS(5000) then
		for player = 0, self.PlayerCount - 1 do
			FrameMan:ClearScreenText(player);
			FrameMan:SetScreenText("Warship collapsing, get your team to a safe place!!!", player, 250, 500, true);
		end
	end

	-- Put explosion
	if self.ExplosionTimer:IsPastSimMS(self.ExplosionInterval) then
		--First explosion is core detonation
		if not self.CoreDetonated then
			print ("Core detonation")
			local core;
		
			--core = CreateAEmitter("Particle Cannon Activated" , "Missions - Earth.rte");
			--core.Pos = self.MainCore:GetCenterPoint();
			--core:EnableEmission(true);
			--MovableMan:AddParticle(core);
			
			core = CreateTDExplosive("Base Particle" , "Missions - Earth.rte");
			core.Pos = self.MainCore:GetCenterPoint();
			MovableMan:AddItem(core);
			core:GibThis()
			self.CoreDetonated = true;
		end
	
		if self.ExplosionInterval > self.ExplosionIntervalMax then
			self.ExplosionInterval = self.ExplosionIntervalMax;
		end
		
		if self.ExplosionInterval > self.ExplosionIntervalMin then
			self.ExplosionInterval = self.ExplosionInterval - 15;
		end
		
		local pos;
		local ok = false;
		
		pos = self.Warship:GetRandomPoint();
		
		-- Select safe position for our explosion to avoid hitting any of our heroes
		while not ok do
			pos = self.Warship:GetRandomPoint();
			if self:NearestHeroDist(pos) > self.SafeExplosionDistance then
				ok = true
			end
		end
		
		local preset = "Explosion "..math.random(10);
		
		-- When all evacuated - destroy the ship with terrain eating explosions
		if self.Evacuated then
			preset = "Explosion 6";
		end
		
		local Charge = CreateMOSRotating(preset, "Missions - Earth.rte")
		self.LastExplosionPos = Vector(pos.X, pos.Y);
		Charge.Pos = pos;
		MovableMan:AddParticle(Charge)
		Charge:GibThis();
		self.ExplosionTimer:Reset();
	end

	-- Shake screen
	if self.CoreDetonated then
		if self.ShakeTimer:IsPastSimMS(self.ShakeInterval) then
			if self.ShakeMagnitude > self.ShakeMagnitudeMin then
				self.ShakeMagnitude = self.ShakeMagnitude - 15;
			end
			
			for player = 0, self.PlayerCount - 1 do
				local actor = self:GetControlledActor(player);
				
				if MovableMan:IsActor(actor) then
					if self.Shake:IsInside(actor.Pos) then
						local offset = Vector((self.ShakeMagnitude / 2) - math.random(self.ShakeMagnitude), (self.ShakeMagnitude / 2) - math.random(self.ShakeMagnitude))
						
						--SceneMan:SetScroll(actor.EyePos + offset, player);
						--self:SetObservationTarget(actor.EyePos + offset, player);
					end
				end
			end
			self.ShakeTimer:Reset();
		end
	end
	
	-- Tell heroes to get the hell out of core chamber
	if not self.CoreDetonated then
		if MovableMan:IsActor(self.Jack) then
			if self.MainCore:IsInside(self.Jack.Pos) then
				self:AddObjectivePoint("RUN AWAY!!!", self.Jack.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			end
		end
		
		if MovableMan:IsActor(self.Tanya) then
			if self.MainCore:IsInside(self.Tanya.Pos) then
				self:AddObjectivePoint("RUN AWAY!!!", self.Tanya.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			end
		end

		if MovableMan:IsActor(self.Grizzly) then
			if self.MainCore:IsInside(self.Grizzly.Pos) then
				self:AddObjectivePoint("RUN AWAY!!!", self.Grizzly.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			end
		end
	end

	local evacuated = 0;
	
	-- Check for victory
	if MovableMan:IsActor(self.Jack) then
		if self.Evacuate:IsInside(self.Jack.Pos) then
			self:AddObjectivePoint("Safe", self.Jack.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			evacuated = evacuated + 1;
		end
	end
	
	if MovableMan:IsActor(self.Tanya) then
		if self.Evacuate:IsInside(self.Tanya.Pos) then
			self:AddObjectivePoint("Safe", self.Tanya.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			evacuated = evacuated + 1;
		end
	end

	if MovableMan:IsActor(self.Grizzly) then
		if self.Evacuate:IsInside(self.Grizzly.Pos) then
			self:AddObjectivePoint("Safe", self.Grizzly.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			evacuated = evacuated + 1;
		end
	end
	
	if evacuated == 3 then
		if self.ActivityState ~= Activity.OVER then
			self.Evacuated = true;
			self.WinnerTeam = self.PlayerTeam;
			ActivityMan:EndActivity();
			for player = 0, self.PlayerCount - 1 do
				self.braindead[player] = true;
				FrameMan:ClearScreenText(player);
			end
		end	
	end
	
	-- Do alarm sound
	if 	self.AlarmTimer:IsPastSimMS(1500) then
		if self.LastExplosionPos ~= nil then
			local fxb = CreateAEmitter("Alarm Effect");
			fxb.Pos = Vector(self.LastExplosionPos.X , self.LastExplosionPos.Y);
			MovableMan:AddParticle(fxb);
		end

		self.AlarmTimer:Reset();
	end
	
	self:AddObjectivePoint("Evacuate!!!", self.Evacuate:GetCenterPoint(), self.PlayerTeam, GameActivity.ARROWDOWN);
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function Ragnarok:DoBrainSelection()
	if self.ActivityState ~= Activity.OVER then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);

			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) then
				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self.AssignedBrains[player] = newBrain;
					self:SwitchToActor(newBrain, player, team);
				end
			else
				self:SetObservationTarget(brain.Pos, player)
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Check winning conditions
-----------------------------------------------------------------------------------------
function Ragnarok:CheckLoser()
	if self.ActivityState ~= Activity.OVER then
		if MovableMan:IsActor(self.Jack) then
			if self.Jack.Health <= 0 then
				self.Jack = nil
			end
		end
		
		if MovableMan:IsActor(self.Grizzly) then
			if self.Grizzly.Health <= 0 then
				self.Grizzly = nil
			end
		end

		if MovableMan:IsActor(self.Tanya) then
			if self.Tanya.Health <= 0 then
				self.Tanya = nil
			end
		end
	
		if self.Jack == nil or self.Grizzly == nil or self.Tanya == nil then
			for player = 0, self.PlayerCount - 1 do
				if MovableMan:IsActor(self.Jack) then
					self:SetPlayerBrain(self.Jack , player);
					self:SwitchToActor(self.Jack, player, self.PlayerTeam);
				elseif MovableMan:IsActor(self.Grizzly) then
					self:SetPlayerBrain(self.Grizzly , player);
					self:SwitchToActor(self.Grizzly, player, self.PlayerTeam);
				elseif MovableMan:IsActor(self.Tanya) then
					self:SetPlayerBrain(self.Tanya , player);
					self:SwitchToActor(self.Tanya, player, self.PlayerTeam);
				end
			end
		
			self.WinnerTeam = self.CPUTeam;
			ActivityMan:EndActivity();
			for player = 0, self.PlayerCount - 1 do
				self.braindead[player] = true;
				FrameMan:ClearScreenText(player);
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Triggers agressive music if some of critical actors was wounded
-----------------------------------------------------------------------------------------
function Ragnarok:ProcessMusic(a1,a2,a3,a4,a5)
	local actors = {}
	
	actors[1] = a1;
	actors[2] = a2;
	actors[3] = a3;
	actors[4] = a4;
	actors[5] = a5;
	
	for i = 1, 5 do
		if MovableMan:IsActor(actors[i]) then
			if actors[i].Health < self.Health[i] then
				if not self.IsAgressive then
					self.IsAgressive = true;
					self:StartMusic(self.MusicModule, self.MusicAgressive)
				end
				self.MusicTimer:Reset();
				self.Health[i] = actors[i].Health
				break;
			end
			self.Health[i] = actors[i].Health
		end
	end

	if self.IsAgressive then
		if self.MusicTimer:IsPastSimMS(self.AgressiveLength) then
			self.IsAgressive = false;
			self:StartMusic(self.MusicModule, self.MusicCalm)
		end
	end
end
-----------------------------------------------------------------------------------------
-- Starts music from file if it's installed
-----------------------------------------------------------------------------------------
function Ragnarok:StartMusic(modulename , musicfile)
	local path = "./"..modulename.."/"..musicfile

	if self:IsFilePathExists(path) then
		AudioMan:ClearMusicQueue();
		AudioMan:PlayMusic(path, -1, -1);
	else
		print ("Can't find music: "..path);
	end	
end
-----------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------
function Ragnarok:IsFilePathExists(path)
	io = require("io");
	
	local file = io.open(path , "r");
	
	if file == nil then
		return false;
	end
	
	file:close();
	return true;
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------



































