-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function Station134:StartActivity()
	print("START! -- Station134:StartActivity()!");

	-- Music related variables
	self.MusicTimer = Timer()
	self.AgressiveLength = 10000
	self.IsAgressive = false
	self.IsStarted = false
	self.MusicCalm = "Super Metroid (calm).ogg"
	self.MusicAgressive = "Abnormal Segment (agressive).ogg"
	self.MusicModule = "Missions - Earth Music.rte"
	self.Health = {}
	
	for i = 1, 5 do
		self.Health[i] = 0;
	end

	self:StartMusic(self.MusicModule, self.MusicCalm)
	-- End of music related variables
	
	
	self.braindead = {};
	self.AssignedBrains = {};

	self.MOIDLimit = 200;

	self.PlayerGold = 0;

   	self.CPUTeam = Activity.TEAM_2;
	self.PlayerTeam = Activity.TEAM_1;
	self.RogueTeam = -1;

	self.Train = nil
	self.Train2 = nil
	self.Train3 = nil
	
	self.FightPhase = {NOFIGHT  = 1, CLEAN = 2, BOSS = 3}
	self.CurrentFightPhase = self.FightPhase.NOFIGHT;
	
	self.LWepList = {"Peacemaker" , "Glock" , "Desert Eagle" , "Uzi" , "Shortgun"};
	self.HWepList = {"Spas 12" , "M60"};
	self.EnemyList = {"Mia" , "Dimitri" , "Sandra" , "Gordon", "Brutus"};	
	self.RobotList = {"Robot 1" , "Robot 2"};	
	self.LastPos = nil;
	
	-- Difficulty related variables
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.LWepList = {"Peacemaker" , "Glock" , "Desert Eagle" };
		self.HWepList = {"Spas 12"};
		self.PositiveIndex = 1.5;
		self.NegativeIndex = 0.5;
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.LWepList = {"Peacemaker" , "Glock" , "Desert Eagle" , "Shortgun"};
		self.HWepList = {"Spas 12"};
		self.PositiveIndex = 1.25;
		self.NegativeIndex = 0.75;
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.LWepList = {"Peacemaker", "Desert Eagle" , "Uzi" , "Shortgun"};
		self.HWepList = {"Spas 12" , "Kar98"};
		self.PositiveIndex = 1.0;
		self.NegativeIndex = 1.0;
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.LWepList = {"Peacemaker" , "Uzi" };
		self.HWepList = {"Spas 12" , "Kar98" , "M60"};
		self.PositiveIndex = 0.85;
		self.NegativeIndex = 1.15;
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.LWepList = {"Uzi"};
		self.HWepList = {"Kar98" , "M60"};
		self.PositiveIndex = 0.70;
		self.NegativeIndex = 1.3;
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self.LWepList = {"Uzi"};
		self.HWepList = {"Kar98" , "M60", "RPG-7", "M16"};
		self.PositiveIndex = 0.55;
		self.NegativeIndex = 1.45;
	end			

	self.RollerInterval = 8000 * self.PositiveIndex
	
	self.AlertTriggered = false;

	self.Underground = {}
	self.TrainStop = {}
	self.SpawnUnder = {}
	
	self.UnderSpawnTimer = Timer()
	
	self.Underground[1] = SceneMan.Scene:GetArea("Underground1");
	self.Underground[2] = SceneMan.Scene:GetArea("Underground2");

	self.TrainStop[1] = SceneMan.Scene:GetArea("TrainStop1");
	self.TrainStop[2] = SceneMan.Scene:GetArea("TrainStop2");

	self.SpawnUnder[1] = SceneMan.Scene:GetArea("SpawnUnder1");
	self.SpawnUnder[2] = SceneMan.Scene:GetArea("SpawnUnder2");
	
	-- We cant't add areas in the loop because CC will never find a suitable location 
	-- for our activity
	self.Ronin = {}
	self.Ronin[1] = SceneMan.Scene:GetArea("Ronin1");
	self.Ronin[2] = SceneMan.Scene:GetArea("Ronin2");
	self.Ronin[3] = SceneMan.Scene:GetArea("Ronin3");
	self.Ronin[4] = SceneMan.Scene:GetArea("Ronin4");
	self.Ronin[5] = SceneMan.Scene:GetArea("Ronin5");
	self.Ronin[6] = SceneMan.Scene:GetArea("Ronin6");
	self.Ronin[7] = SceneMan.Scene:GetArea("Ronin7");
	self.Ronin[8] = SceneMan.Scene:GetArea("Ronin8");
	self.Ronin[9] = SceneMan.Scene:GetArea("Ronin9");
	self.Ronin[10] = SceneMan.Scene:GetArea("Ronin10");
	
	self.RoninGuard = {}
	self.RoninGuard[1] = SceneMan.Scene:GetArea("Guard1");
	self.RoninGuard[2] = SceneMan.Scene:GetArea("Guard2");
	self.RoninGuard[3] = SceneMan.Scene:GetArea("Guard3");
	self.RoninGuard[4] = SceneMan.Scene:GetArea("Guard4");
	self.RoninGuard[5] = SceneMan.Scene:GetArea("Guard5");
	self.RoninGuard[6] = SceneMan.Scene:GetArea("Guard6");

	self.PatrolZones = {}; 
	self.PatrolWaypoints = {};

	self.PatrolZones[1] = SceneMan.Scene:GetArea("PatrolZone1");
	self.PatrolZones[2] = SceneMan.Scene:GetArea("PatrolZone2");
	self.PatrolZones[3] = SceneMan.Scene:GetArea("PatrolZone3");
	self.PatrolZones[4] = SceneMan.Scene:GetArea("PatrolZone4");
	
	self.PatrolWaypoints[1] = {SceneMan.Scene:GetArea("PatrolPoint1L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint1R"):GetCenterPoint()};
	self.PatrolWaypoints[2] = {SceneMan.Scene:GetArea("PatrolPoint2L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint2R"):GetCenterPoint()};
	self.PatrolWaypoints[3] = {SceneMan.Scene:GetArea("PatrolPoint3L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint3R"):GetCenterPoint()};
	self.PatrolWaypoints[4] = {SceneMan.Scene:GetArea("PatrolPoint4L"):GetCenterPoint(), SceneMan.Scene:GetArea("PatrolPoint4R"):GetCenterPoint()};
	
	self.GenericTimer = Timer();
	self.GenericTimer:Reset();

	self.TeleportTimer = Timer();
	self.TeleportTimer:Reset();

	self.RollerTimer = Timer();
	self.RollerTimer:Reset();
	
	self.EnumEven = true;
	
	--Spawn Our Heroes
	self.Jack = CreateAHuman("Jack" , "UniTec.rte");
	self.Jack.Team = self.PlayerTeam;
	self.Jack:AddInventoryItem(CreateHDFirearm("Franchi SPAS-15" , "UniTec.rte"));
	self.Jack.AIMode = Actor.AIMODE_SENTRY;
	for player = 0, self.PlayerCount - 1 do
		self:SetPlayerBrain(self.Jack, player);
	end

	self.Lynx = CreateAHuman("Brain Lynx" , "UniTec.rte");
	self.Lynx.Team = self.PlayerTeam;
	self.Lynx:AddInventoryItem(CreateHDFirearm("TDI Vector" , "UniTec.rte"));
	self.Lynx:AddInventoryItem(CreateHDFirearm("SV Dragunov" , "UniTec.rte"));
	self.Lynx.AIMode = Actor.AIMODE_SENTRY;

	self.HeroShip = CreateACDropShip("UniTec Drop Ship" , "Unitec.rte");
	self.HeroShip.Team = self.PlayerTeam;
	self.HeroShip:AddInventoryItem(self.Jack);
	self.HeroShip:AddInventoryItem(self.Lynx);
	self.HeroShip.Pos = Vector(SceneMan.Scene:GetArea("DropZone"):GetCenterPoint().X , 200); -- Gameplay
	self.HeroShip.Pos = Vector(1350, 200); -- Debug
	self.HeroShip:SetControllerMode(Controller.CIM_AI, -1);
	MovableMan:AddActor(self.HeroShip);
	
	self:SpawnRonins();
	self:SetTeamFunds(0 , self.PlayerTeam);
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
-- This function is called when mission is paused
function Station134:PauseActivity(pause)
    print("PAUSE! -- Station134:PauseActivity()!");
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
-- This function is called after mission has ended
function Station134:EndActivity()
    print("END! -- Station134:EndActivity()!");
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Station134:SpawnRonins()
	print ("SpawnRonin")
	local ship;
	local actor;
	
	-- Spawn leader guards
	for i = 1, #self.RoninGuard do
		if MovableMan:GetMOIDCount() <= self.MOIDLimit then
			actor = CreateAHuman(self.EnemyList[math.random(#self.EnemyList)] , "Ronin.rte");
			actor:AddInventoryItem(CreateHDFirearm(self.HWepList[math.random(#self.HWepList)] , "Ronin.rte"))
			actor:AddInventoryItem(CreateHDFirearm("RPG-7" , "Ronin.rte"))
			actor.Pos = self.RoninGuard[i]:GetCenterPoint();
			actor.Team = self.CPUTeam; -- Gameplay
			actor.AIMode = Actor.AIMODE_SENTRY;
			
			if i == 1 or i == 3 or i == 5 then
				actor.HFlipped = true
			end
			
			MovableMan:AddActor(actor);
		end
	end
	
	-- Spawn ordinary Ronin
	for i = 1, #self.Ronin do
		if math.random() < 0.6 then
			if MovableMan:GetMOIDCount() <= self.MOIDLimit then
				actor = CreateAHuman(self.RobotList[math.random(#self.RobotList)] , "Base.rte");
				actor:AddInventoryItem(CreateHDFirearm(self.LWepList[math.random(#self.LWepList)] , "Ronin.rte"))
				actor:AddInventoryItem(CreateHDFirearm("Heavy Digger" , "Base.rte"))
				actor.Pos = self.Ronin[i]:GetCenterPoint();
				actor.Team = self.CPUTeam; -- Gameplay
				actor.AIMode = Actor.AIMODE_GOLDDIG;
				MovableMan:AddActor(actor);
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Station134:IsEven(number)
	if number % 2 == 0 then
		return true;
	else
		return false;
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Station134:PatrolControl()
	local unitcount = 0;

	-- Set flag to chech even or odd actors
	self.EnumEven = not self.EnumEven;
	
	-- Resend all enemy troops to closes patrol areas if alert is off
	-- Scan all patrol zones. If we have AIMODE_SENTRY troops there,
	-- GOTO them to the most far patrol point
	for actor in MovableMan.Actors do
		-- to reduce the lag at every cycle we control only odd or even actor. It would be more efficint to count actors every time, because more ID's can be odd or even but it was written some time ago when I was dumber )))
		if actor.Team == self.CPUTeam and actor.AIMode ~= Actor.AIMODE_GOTO and actor.ClassName == "AHuman" then
			unitcount = unitcount + 1;
			if self:IsEven(unitcount) == self.EnumEven then
				for i = 1 , #self.PatrolZones do
					if self.PatrolZones[i]:IsInside(actor.Pos) then
						-- Calc distances to available patrol waypoint and send actor to the most far
						local dist1 = math.sqrt((actor.Pos.X - self.PatrolWaypoints[i][1].X) ^ 2 + (actor.Pos.Y - self.PatrolWaypoints[i][1].Y) ^ 2);
						local dist2 = math.sqrt((actor.Pos.X - self.PatrolWaypoints[i][2].X) ^ 2 + (actor.Pos.Y - self.PatrolWaypoints[i][2].Y) ^ 2);

						-- Flash white for debugging purposes
						-- Also you can spawn actor of your own team change team in IF and enable DrawWaypoints to see where you troops were sent. VERY helpful!
						-- actor:FlashWhite(50);
						actor.AIMode = Actor.AIMODE_GOTO;
						actor:ClearAIWaypoints();
						actor:DrawWaypoints(true);
						if dist1 < dist2 then
							actor:AddAISceneWaypoint(self.PatrolWaypoints[i][2]);
						else
							actor:AddAISceneWaypoint(self.PatrolWaypoints[i][1]);
						end --if
						break;
					end -- if
				end -- for
			end -- if 
		end -- if
	end -- for		
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function Station134:UpdateActivity()
   	self:ClearObjectivePoints();
	self:DoBrainSelection()

	self:ProcessMusic(self.Jack, self.Lynx, nil, nil, nil)
	
	if self.CurrentFightPhase == self.FightPhase.NOFIGHT then
		self:PhaseNoFight();
	elseif self.CurrentFightPhase == self.FightPhase.CLEAN then
		self:PhaseClean();
		self:CheckLoser();
	elseif self.CurrentFightPhase == self.FightPhase.BOSS then
		self:PhaseBoss();
		self:CheckLoser();
	end
	
	-- print (self.CurrentFightPhase)
	
	self:PatrolControl();
	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Station134:PhaseNoFight()
	-- Control ship
	if MovableMan:IsActor(self.HeroShip) then
		for player = 0, self.PlayerCount - 1 do
			self:SetObservationTarget(self.HeroShip.Pos, player);
		end
		self.HeroShip:SetControllerMode(Controller.CIM_AI, -1);
	end	

	-- Show heroes marks
	if not self.GenericTimer:IsPastSimMS(14000) then
		if MovableMan:IsActor(self.Jack) then
			self:AddObjectivePoint("Jack", self.Jack.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
		
		if MovableMan:IsActor(self.Lynx) then
			self:AddObjectivePoint("Lynx", self.Lynx.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	else
		self:AdvanceToClean();
	end

	for player = 0, self.PlayerCount - 1 do
		FrameMan:ClearScreenText(player);
		FrameMan:SetScreenText("Just waste those ronin meat bags and their tin cans.\nDon't lose any of your teammates", player, -1, 1000, true);
	end
	
	-- Kill all targets
	--[[for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam and actor.PresetName ~= "Dafred" and actor.ClassName == "AHuman" then
	 		actor.Health = actor.Health - math.random() / 100;
		end
	end--]]--
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Station134:AdvanceToClean()
	print ("AdvanceToClean")
	self:SetTeamFunds(self.PlayerGold , self.PlayerTeam);
	
	self.CurrentFightPhase = self.FightPhase.CLEAN;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Station134:PhaseClean()
	local enemiesleft = 0;
	local triggeralert = false;
	
	local curactor = ActivityMan:GetActivity():GetControlledActor(self.PlayerTeam);
	local maxactorstotrack = 5; -- Actors number to track
	local enemies = {}
	local dists = {}
	
	for i = 1, maxactorstotrack do
		enemies[i] = nil;
		dists[i] = 100000;
	end
	
	-- Count remaining enemy troops
	for actor in MovableMan.Actors do
		if actor.Team == self.CPUTeam and actor.ClassName == "AHuman" then
			enemiesleft = enemiesleft + 1;
			
			if MovableMan:IsActor(curactor) then
				--local dist = math.sqrt((actor.Pos.X - curactor.Pos.X) ^ 2 + (actor.Pos.Y - curactor.Pos.Y) ^ 2);
				local dist = SceneMan:ShortestDistance(actor.Pos, curactor.Pos, true).Magnitude;
				
				local maxdist = 0;
				local maxindex = 0;
				
				-- Find most far actor
				for i = 1, maxactorstotrack do
					if dists[i] > maxdist then
						maxdist = dists[i];
						maxindex = i;
					end
				end
				
				-- If our actor closer to player-controlled actor than the most far, then replace it
				if dist < maxdist then
					dists[maxindex] = dist;
					enemies[maxindex] = actor;
				end
			end
		end
	end

	for player = 0, self.PlayerCount - 1 do
		FrameMan:ClearScreenText(player);
		FrameMan:SetScreenText("Remaining targets: "..tostring(enemiesleft), player, 0, 1, false);
	end

	-- Mark closest actors
	for i = 1, maxactorstotrack do
		if enemies[i] ~= nil then
			self:AddObjectivePoint("Kill", enemies[i].AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		end
	end

	if enemiesleft == 0 then
		self:AdvanceToBoss();
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Station134:AdvanceToBoss()
	print ("AdvanceToBoss")

	self.Cart1Pos = SceneMan.Scene:GetArea("DropZone"):GetCenterPoint();
	self.Cart2Pos = self.Cart1Pos + Vector(-200 , 0);
	self.Cart3Pos = self.Cart2Pos + Vector(-200 , 0);
	
	self.TrainSpawned = false;
	
	self.CurrentFightPhase = self.FightPhase.BOSS;
	self.GenericTimer:Reset();
	self.RollerTimer:Reset();
	
	self.TeleportInterval = 750;
	
	if not self.IsAgressive then
		self.IsAgressive = true;
		self:StartMusic(self.MusicModule, self.MusicAgressive)
	end
	self.MusicTimer:Reset();
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function Station134:PhaseBoss()
	-- Always play agressive music
	self.MusicTimer:Reset();

	if not self.GenericTimer:IsPastSimMS(5000) then --DEBUG Change to 5000 for gameplay
		for player = 0, self.PlayerCount - 1 do
			FrameMan:ClearScreenText(player);
			FrameMan:SetScreenText("Something weird going on, be careful", player, 100, 1000, true);
		end
		
		if self.TeleportTimer:IsPastSimMS(self.TeleportInterval) then
			if self.TeleportInterval > 400 then
				self.TeleportInterval = self.TeleportInterval - 175;
			end
		
			if math.random() < 0.50 then
				local Charge = CreateMOSRotating("GeneratorExplosion", "Missions - Earth.rte")
				Charge.Pos = self.Cart1Pos + Vector(-200 + math.random(300), -30 + math.random(60));
				MovableMan:AddParticle(Charge)
				Charge:GibThis();
			else
				local Charge = CreateMOSRotating("GeneratorExplosion", "Missions - Earth.rte")
				Charge.Pos = self.Cart3Pos + Vector(-200 + math.random(300), -30 + math.random(60));
				MovableMan:AddParticle(Charge)
				Charge:GibThis();
			end
		
			self.TeleportTimer:Reset()
		end
	else
		if not self.TrainSpawned then
			-- Spawn train
			self.Train = CreateACRocket("Ronin Station Bullet Train" , "Missions - Earth.rte");
			self.Train.Pos = self.Cart1Pos;
			self.Train.Team = self.CPUTeam;
			self.Train.AIMode = Actor.AIMODE_STAY;
			MovableMan:AddActor(self.Train);
			self.Train:FlashWhite(750);

			self.Train2 = CreateACRocket("Ronin Station Bullet Cart One" , "Missions - Earth.rte");
			self.Train2.Pos = self.Cart2Pos;
			self.Train2.Team = self.CPUTeam;
			self.Train2.AIMode = Actor.AIMODE_STAY;
			MovableMan:AddActor(self.Train2);
			self.Train2:FlashWhite(750);

			self.Train3 = CreateACRocket("Ronin Station Bullet Cart Two" , "Missions - Earth.rte");
			self.Train3.Pos = self.Cart3Pos;
			self.Train3.Team = self.CPUTeam;
			self.Train3.AIMode = Actor.AIMODE_STAY;
			MovableMan:AddActor(self.Train3);
			self.Train3:FlashWhite(750);--]]--

			
			self.RollerTimer:Reset();
			self.TrainSpawned = true;
		end
	end
	
	if self.TrainSpawned then
		-- Spawn underground hunting ronins
		if self.UnderSpawnTimer:IsPastSimMS(6000) and MovableMan:IsActor(self.Train) then
			local occupied = {}
			
			-- Check if our heores hide in basements
			for i = 1, 2 do
				occupied[i] = false;
				if MovableMan:IsActor(self.Jack) and MovableMan:IsActor(self.Lynx) then
					if self.Underground[i]:IsInside(self.Jack.Pos) or self.Underground[i]:IsInside(self.Lynx.Pos) then
						occupied[i] = true
					end
				end
			end
			
			-- If so spawn ronins when train stops
			for i = 1, 2 do
				if self.TrainStop[i]:IsInside(self.Train.Pos) and occupied[i] and self.Train.Vel.X < 1 then
					if MovableMan:GetMOIDCount() <= self.MOIDLimit then
						actor = CreateAHuman(self.EnemyList[math.random(#self.EnemyList)] , "Ronin.rte");
						actor:AddInventoryItem(CreateHDFirearm(self.LWepList[math.random(#self.LWepList)] , "Ronin.rte"))
						actor.Pos = self.SpawnUnder[i]:GetCenterPoint();
						actor.Team = self.CPUTeam; -- Gameplay
						actor.AIMode = Actor.AIMODE_BRAINHUNT;
						MovableMan:AddActor(actor);
						self.UnderSpawnTimer:Reset()
						break;
					end
				end
			end
		end
	
		-- Process 2nd cart
		if not MovableMan:IsActor(self.Train2) then
			self.Train2 = nil;
		else
			-- Correct 2rd cart speed
			if MovableMan:IsActor(self.Train) and MovableMan:IsActor(self.Train2) then
				local trainvelcorrection = nil;
				local dist = SceneMan:ShortestDistance(self.Train.Pos, self.Train2.Pos, true)
			
				if dist.Magnitude < 199 then
					trainvelcorrection = Vector(-((200 - math.abs(dist.X)) / 50), 0)
				end

				if dist.Magnitude > 201 then
					trainvelcorrection = Vector((math.abs(dist.X) - 200) / 50, 0)
				end
				
				if trainvelcorrection ~= nil then
					self.Train2.Vel = Vector(self.Train.Vel.X, self.Train2.Vel.Y) + trainvelcorrection;
				else
					self.Train2.Vel = Vector(self.Train.Vel.X, self.Train2.Vel.Y);
				end
			end
		end
		
		-- Process 3rd cart
		if not MovableMan:IsActor(self.Train3) then
			self.Train3 = nil;
		else
			-- Spawn blast runners and process 3rd cart
			if self.RollerTimer:IsPastSimMS(self.RollerInterval) then
				if MovableMan:GetMOIDCount() <= self.MOIDLimit then
					for actor in MovableMan.Actors do
						if actor.Team == self.CPUTeam and actor.PresetName == "Blast Runner" then
							--if math.random() < 0.25 then
								actor.Health = 0;
							--end
						end
					end
				
					actor = CreateACrab("Blast Runner" , "Coalition.rte");
					actor.Pos = self.Train3.Pos + Vector(-100, 10);
					actor.Vel = Vector(-15, -25);
					actor.Team = self.CPUTeam;
					actor.AIMode = Actor.AIMODE_BRAINHUNT;
					MovableMan:AddActor(actor);
					self.RollerTimer:Reset();
				end
			end
			
			-- Correct 3rd cart speed
			if MovableMan:IsActor(self.Train3) then
				local targetpos = nil;
				local targetvel = nil;
			
				-- If 2nd cart is destroyed cart follows loco
				if MovableMan:IsActor(self.Train2) then
					targetpos = self.Train2.Pos;
					targetvel = self.Train2.Vel;
				else
					if MovableMan:IsActor(self.Train) then
						targetpos = self.Train.Pos;
						targetvel = self.Train.Vel;
					end
				end
				
				if targetvel ~= nil and targetpos ~= nil then
					local trainvelcorrection = nil;
					local dist = SceneMan:ShortestDistance(targetpos, self.Train3.Pos, true)
					
					if dist.Magnitude < 199 then
						trainvelcorrection = Vector(-((200 - math.abs(dist.X)) / 50), 0)
					end

					if dist.Magnitude > 201 then
						trainvelcorrection = Vector((math.abs(dist.X) - 200) / 50, 0)
					end

					if trainvelcorrection ~= nil then
						self.Train3.Vel = Vector(targetvel.X, self.Train3.Vel.Y) + trainvelcorrection;
					else
						self.Train3.Vel = Vector(targetvel.X, self.Train3.Vel.Y);
					end
				end
			end
		end
		
		if MovableMan:IsActor(self.Train) then
			self:AddObjectivePoint("Kill", self.Train.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
		else
			print ("Train dead")
			self.Train = nil;

			if MovableMan:IsActor(self.Train2) then
				self.Train2:GibThis();
			end

			if MovableMan:IsActor(self.Train3) then
				self.Train3:GibThis();
			end
			
			if self.ActivityState ~= Activity.OVER then
				self.WinnerTeam = self.PlayerTeam;
				ActivityMan:EndActivity();
				for player = 0, self.PlayerCount - 1 do
					self.braindead[player] = true;
					FrameMan:ClearScreenText(player);
				end
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function Station134:DoBrainSelection()
	if self.ActivityState ~= Activity.OVER then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);

			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) then
				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self.AssignedBrains[player] = newBrain;
					self:SwitchToActor(newBrain, player, team);
				end
			else
				self:SetObservationTarget(brain.Pos, player)
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Check winning conditions
-----------------------------------------------------------------------------------------
function Station134:CheckLoser()
	if self.ActivityState ~= Activity.OVER then
		if MovableMan:IsActor(self.Jack) then
			if self.Jack.Health <= 0 then
				self.Jack = nil
			end
		else
			self.Jack = nil
		end
		
		if MovableMan:IsActor(self.Lynx) then
			if self.Lynx.Health <= 0 then
				self.Lynx = nil
			end
		else
			self.Lynx = nil
		end
	
		if self.Jack == nil or self.Lynx == nil then
			for player = 0, self.PlayerCount - 1 do
				if MovableMan:IsActor(self.Jack) then
					self:SetPlayerBrain(self.Jack , player);
					self:SwitchToActor(self.Jack, player, self.PlayerTeam);
				elseif MovableMan:IsActor(self.Lynx) then
					self:SetPlayerBrain(self.Lynx , player);
					self:SwitchToActor(self.Lynx, player, self.PlayerTeam);
				end
			end
		
			self.WinnerTeam = self.CPUTeam;
			for player = 0, self.PlayerCount - 1 do
				self.braindead[player] = true;
				FrameMan:ClearScreenText(player);
			end
			ActivityMan:EndActivity();
		end
	end
end
-----------------------------------------------------------------------------------------
-- Enter orbit, clear money
-----------------------------------------------------------------------------------------
function Station134:CraftEnteredOrbit()
	self:SetTeamFunds(0 , self.PlayerTeam);
end
-----------------------------------------------------------------------------------------
-- Triggers agressive music if some of critical actors was wounded
-----------------------------------------------------------------------------------------
function Station134:ProcessMusic(a1,a2,a3,a4,a5)
	local actors = {}
	
	actors[1] = a1;
	actors[2] = a2;
	actors[3] = a3;
	actors[4] = a4;
	actors[5] = a5;
	
	for i = 1, 5 do
		if MovableMan:IsActor(actors[i]) then
			if actors[i].Health < self.Health[i] then
				if not self.IsAgressive then
					self.IsAgressive = true;
					self:StartMusic(self.MusicModule, self.MusicAgressive)
				end
				self.MusicTimer:Reset();
				self.Health[i] = actors[i].Health
				break;
			end
			self.Health[i] = actors[i].Health
		end
	end

	if self.IsAgressive then
		if self.MusicTimer:IsPastSimMS(self.AgressiveLength) then
			self.IsAgressive = false;
			self:StartMusic(self.MusicModule, self.MusicCalm)
		end
	end
end
-----------------------------------------------------------------------------------------
-- Starts music from file if it's installed
-----------------------------------------------------------------------------------------
function Station134:StartMusic(modulename , musicfile)
	local path = "./"..modulename.."/"..musicfile

	if self:IsFilePathExists(path) then
		AudioMan:ClearMusicQueue();
		AudioMan:PlayMusic(path, -1, -1);
	else
		print ("Can't find music: "..path);
	end	
end
-----------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------
function Station134:IsFilePathExists(path)
	io = require("io");
	
	local file = io.open(path , "r");
	
	if file == nil then
		return false;
	end
	
	file:close();
	return true;
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------



































